Imports System
Imports System.io
Imports System.Xml

Public Class Plugin
    Inherits LcdStudio.CoreInterfaces.AbstractDataPlugin

#Region "    GUI init     "
    Public Overrides ReadOnly Property Serializable() As Boolean
        Get
            Return True
        End Get
    End Property

    Public Overrides ReadOnly Property ConfigType() As Type
        Get
            Return GetType(WeatherSettings)
        End Get
    End Property

    Public Overrides ReadOnly Property ConfigPanel() As System.Windows.Forms.Control
        Get
            Return New GUISetting_Tab(CType(_settings, WeatherSettings))
        End Get
    End Property
#End Region

#Region "    Varibles     "

    Private TranslationArray1 As New ArrayList
    Private TranslationArray2 As New ArrayList
    Public Shared TranslationRead As Boolean = False
    Public Shared Group_ID As Integer

    'Private TranslationText As String
    Private ForecastLocation As String
    Private urlFound As Boolean = False
    Private weatherURL As String
    Private FormatURL As String
    Private SettingINI As String
    Private Lasterror As String
    Public Shared UseLog As Boolean

    Structure wind
        Public DirectionDegress As String
        Public Direction As String
        Public gust As String
        Public Speed As String
    End Structure

    Structure moon
        Public IconCode As String
        Public description As String
    End Structure

    Structure uv
        Public indexValue As String
        Public description As String
    End Structure

    Structure bar
        Public CurrentPressure As String
        Public description As String
    End Structure

    Structure cc
        Public Currenttemp As String
        Public feelsTemp As String
        Public Timeupdated As String
        Public Condition As String
        Public IconCode As String
        Public observation As String
        Public humidity As String
        Public visibility As String
        Public DewPoint As String

        Public TheWind As wind
        Public barometric As bar
        Public UVIndex As uv
        Public TheMoon As moon
    End Structure

    Structure day
        Public HighTmp As String
        Public LowTmp As String
        Public Sunrise As String
        Public Sunset As String
        Public TheDay As String
        Public TheDate As String
        Public dayicon As String
        Public daycondition As String
        Public Shortdaycondition As String
        Public dayprecipitation As String
        Public DayHumidity As String
        Public DayWind As wind
        Public nighticon As String
        Public nightcondition As String
        Public ShortNightcondition As String
        Public nightprecipitation As String
        Public NightHumidity As String
        Public NightWind As wind
    End Structure

    Private CurrentCondition As cc
    Private days() As day
    Public daycount As Integer
    Private sr As StreamReader
    Private strSearch As String
    Private StartPos1 As Integer
    Private StartPos2 As Integer
    Private LocationsID() As String

#End Region

#Region "    LCDStudio Plugin     "
    Dim dayfor As Integer
    Dim LocFor As Integer
    Dim KeyString As String = Nothing
    Dim treeString As String = Nothing

    Public Overrides Sub RegisterData(ByVal ds As LcdStudio.CoreInterfaces.IDataService)

        Dim InitialSettings As WeatherSettings = CType(_settings, WeatherSettings)

        If InitialSettings.enablelog = "True" Then
            InitialSettings.enablelog = "False"
            UseLog = True
        End If

        Log("Starting RegisterData")
        If UseLog = True Then
            Log("Retrived Settings:" & vbCrLf & "Number of Days " & InitialSettings.NumDays & vbCrLf & "Temp Format " & InitialSettings.TempFormat & vbCrLf & "Translation File " & InitialSettings.Translation & vbCrLf & "Update Time " & InitialSettings.Updatetime & vbCrLf & "Weather ID " & InitialSettings.WeatherID)
        End If
        daycount = InitialSettings.NumDays
        If daycount = Nothing Then daycount = 5
        If InitialSettings.Updatetime = Nothing Then InitialSettings.Updatetime = "600000"

        ReDim days(daycount - 1)
        LocationsID = Split(InitialSettings.WeatherID, ",")
        Log("Starting Locations Registers")

        For LocFor = 1 To LocationsID.Length
            If LocationsID.Length = 1 Then
                Log("Setting Single Locations Strings")
                KeyString = "weather"
                treeString = "weather"
            Else
                Log("Setting Multiple Locations Strings")
                KeyString = "weather.location" & Format(LocFor, "00")
                treeString = "weather\location" & Format(LocFor, "00")
            End If

            For dayfor = 1 To days.Length
                Log("Registering day" & dayfor)
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".ForecastDay", treeString & "\day" & Format(dayfor, "00") & "\Forecast Day")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".ForecastHigh", treeString & "\day" & Format(dayfor, "00") & "\High Temperature")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".ForecastLow", treeString & "\day" & Format(dayfor, "00") & "\Low Temperature")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".ForecastSunrise", treeString & "\day" & Format(dayfor, "00") & "\Sunrise")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".ForecastSunset", treeString & "\day" & Format(dayfor, "00") & "\Sunset")

                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Day.Condition", treeString & "\day" & Format(dayfor, "00") & "\Day\Forecast Condition")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Day.Icon", treeString & "\day" & Format(dayfor, "00") & "\Day\Forecast Icon")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Day.Precipitation", treeString & "\day" & Format(dayfor, "00") & "\Day\Precipitation")

                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Day.WindDirection", treeString & "\day" & Format(dayfor, "00") & "\Day\Wind Direction")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Day.WindDirectiondegress", treeString & "\day" & Format(dayfor, "00") & "\Day\Wind Direction in Degrees")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Day.WindGust", treeString & "\day" & Format(dayfor, "00") & "\Day\Maximum Wind Gust Speed")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Day.WindSpeed", treeString & "\day" & Format(dayfor, "00") & "\Day\Wind Speed")

                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Night.Condition", treeString & "\day" & Format(dayfor, "00") & "\Night\Forecast Condition")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Night.Icon", treeString & "\day" & Format(dayfor, "00") & "\Night\Forecast Icon")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Night.Precipitation", treeString & "\day" & Format(dayfor, "00") & "\Night\Precipitation")

                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Night.WindDirection", treeString & "\day" & Format(dayfor, "00") & "\Night\Wind Direction")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Night.WindDirectiondegress", treeString & "\day" & Format(dayfor, "00") & "\Night\Wind Direction in Degrees")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Night.WindGust", treeString & "\day" & Format(dayfor, "00") & "\Night\Maximum Wind Gust Speed")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Night.WindSpeed", treeString & "\day" & Format(dayfor, "00") & "\Night\Wind Speed")

                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".ForecastDate", treeString & "\day" & Format(dayfor, "00") & "\Forecast Date")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Day.ShortCondition", treeString & "\day" & Format(dayfor, "00") & "\Day\Short Forecast Condition")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Night.ShortCondition", treeString & "\day" & Format(dayfor, "00") & "\Night\Short Forecast Condition")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Day.Humidity", treeString & "\day" & Format(dayfor, "00") & "\Day\Humidity")
                ds.RegisterVariable(Group, KeyString & ".day" & Format(dayfor, "00") & ".Night.Humidity", treeString & "\day" & Format(dayfor, "00") & "\Night\Humidity")

            Next
            Log("Starting cc Registers")

            ds.RegisterVariable(Group, KeyString & ".cc.TimeUpdated", treeString & "\cc\Time Updated")
            ds.RegisterVariable(Group, KeyString & ".cc.Currenttemp", treeString & "\cc\Current temperature")
            ds.RegisterVariable(Group, KeyString & ".cc.Condition", treeString & "\cc\Current Condition")
            ds.RegisterVariable(Group, KeyString & ".cc.icon", treeString & "\cc\Current Icon")

            ds.RegisterVariable(Group, KeyString & ".cc.WindDirection", treeString & "\cc\Wind Direction")
            ds.RegisterVariable(Group, KeyString & ".cc.WindDegrees", treeString & "\cc\Wind Direction in Degrees")
            ds.RegisterVariable(Group, KeyString & ".cc.WindIcon", treeString & "\cc\Wind Direction Icon")
            ds.RegisterVariable(Group, KeyString & ".cc.WindForce", treeString & "\cc\Wind Force")
            ds.RegisterVariable(Group, KeyString & ".cc.gust", treeString & "\cc\Maximum Wind Gust Speed")
            ds.RegisterVariable(Group, KeyString & ".cc.speed", treeString & "\cc\Wind Speed")

            ds.RegisterVariable(Group, KeyString & ".cc.FeelsTemp", treeString & "\cc\Feels Like Temp")
            ds.RegisterVariable(Group, KeyString & ".cc.Observation", treeString & "\cc\Observation Station")
            ds.RegisterVariable(Group, KeyString & ".cc.Humidity", treeString & "\cc\Humidity")
            ds.RegisterVariable(Group, KeyString & ".cc.Visibility", treeString & "\cc\Visibility")
            ds.RegisterVariable(Group, KeyString & ".cc.Dewpoint", treeString & "\cc\Dew Point")
            ds.RegisterVariable(Group, KeyString & ".cc.barometricPressure", treeString & "\cc\Barometric Pressure")
            ds.RegisterVariable(Group, KeyString & ".cc.barometricDescription", treeString & "\cc\Barometric Description")

            ds.RegisterVariable(Group, KeyString & ".cc.uvindex", treeString & "\cc\UV Index")
            ds.RegisterVariable(Group, KeyString & ".cc.UVdescription", treeString & "\cc\UV Description")
            ds.RegisterVariable(Group, KeyString & ".cc.Moonicon", treeString & "\cc\Moon Icon Code")
            ds.RegisterVariable(Group, KeyString & ".cc.Moondescription", treeString & "\cc\Moon Description")

            ds.RegisterVariable(Group, KeyString & ".Location", treeString & "\Location")
            ds.RegisterVariable(Group, KeyString & ".URL", treeString & "\URL")
            ds.RegisterVariable(Group, KeyString & ".LastError", treeString & "\Last Error")
        Next

        ds.RegisterVariable(Group, "weather.working", "weather\Working")
        Me.UpdateInterval = InitialSettings.Updatetime 'Update every 10000ms (10 sec)

    End Sub

    Public Overrides Sub UpdateData(ByVal ds As LcdStudio.CoreInterfaces.IDataService)

        Dim tmp_i As Integer
        Dim virginHTML As String

        Dim tmp_n As Integer
        ds.SetValue("weather.working", False)

        Log("Starting Update Data")

        Dim WeatherSettings As WeatherSettings = CType(_settings, WeatherSettings)

        If UseLog = True Then
            Log("Retrived Settings:" & vbCrLf & "Number of Days " & WeatherSettings.NumDays & vbCrLf & "Temp Format " & WeatherSettings.TempFormat & vbCrLf & "Translation File " & WeatherSettings.Translation & vbCrLf & "Update Time " & WeatherSettings.Updatetime & vbCrLf & "Weather ID " & WeatherSettings.WeatherID)
        End If

        Select Case UCase(WeatherSettings.TempFormat)
            Case "A"
                FormatURL = "&unit=s"
            Case "M"
                FormatURL = "&unit=m"
            Case "E"
                FormatURL = "&unit=s&ut=C"
            Case Else
                FormatURL = WeatherSettings.TempFormat
        End Select


        'If LocationsID.Length > 1 Then
        Log("Starting Locations UpdateData")
        Log(LocationsID.Length & " Locations to Retrieve data for")
        Dim working(LocationsID.Length) As Boolean

        For LocFor As Integer = 1 To LocationsID.Length

            If LocationsID.Length = 1 Then
                Log("Setting Single Locations Strings")
                KeyString = "weather"
            Else
                Log("Setting Multiple Locations Strings")
                KeyString = "weather.location" & Format(LocFor, "00")
            End If

            working(LocFor) = False

            weatherURL = Nothing
            virginHTML = Nothing
            tmp_i = Nothing
            tmp_n = Nothing
            ReDim days(daycount - 1)
            CurrentCondition = Nothing
            Lasterror = Nothing

            weatherURL = "http://xoap.weather.com/weather/local/" & LocationsID(LocFor - 1) & "?cc=*&dayf=" & daycount & FormatURL
            Log("URL " & weatherURL)
            virginHTML = GetPageHTML(weatherURL, 5, WeatherSettings.proxy, Lasterror, True)
            Log(virginHTML)

            If virginHTML <> "" Then

                Log("Starting XML Reading")

                Dim m_xmld As XmlDocument = Nothing
                Dim m_nodelist As XmlNodeList = Nothing
                Dim m_node As XmlNode = Nothing

                m_xmld = New XmlDocument
                'Load the Xml file
                m_xmld.LoadXml(virginHTML)

                Log("/weather/loc")
                'Get the list of name nodes for loc
                m_nodelist = m_xmld.SelectNodes("/weather/loc")
                'Loop through the nodes
                For Each m_node In m_nodelist
                    'Get the Gender Attribute Value
                    Dim idAttribute As String = m_node.Attributes.GetNamedItem("id").Value

                    Log("XML ID " & idAttribute)

                    For tmp_i = 0 To m_node.ChildNodes.Count - 1

                        Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                        If m_node.ChildNodes.Item(tmp_i).Name = "dnam" Then
                            ForecastLocation = m_node.ChildNodes.Item(tmp_i).InnerText
                            Exit For
                        End If
                    Next
                Next

                Log("/weather/cc")
                'Get the list of name nodes for Current Condition
                m_nodelist = m_xmld.SelectNodes("/weather/cc")
                'Loop through the nodes
                For Each m_node In m_nodelist
                    'Get the Gender Attribute Value
                    For tmp_i = 0 To m_node.ChildNodes.Count - 1
                        Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                        If m_node.ChildNodes.Item(tmp_i).Name = "lsup" Then CurrentCondition.Timeupdated = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "tmp" Then CurrentCondition.Currenttemp = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "t" Then CurrentCondition.Condition = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "icon" Then CurrentCondition.IconCode = m_node.ChildNodes.Item(tmp_i).InnerText

                        If m_node.ChildNodes.Item(tmp_i).Name = "flik" Then CurrentCondition.feelsTemp = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "obst" Then CurrentCondition.observation = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "hmid" Then CurrentCondition.humidity = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "vis" Then CurrentCondition.visibility = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "dewp" Then CurrentCondition.DewPoint = m_node.ChildNodes.Item(tmp_i).InnerText
                    Next
                Next

                Log("/Weather/cc/bar")

                m_nodelist = m_xmld.SelectNodes("/weather/cc/bar")
                For Each m_node In m_nodelist
                    For tmp_i = 0 To m_node.ChildNodes.Count - 1
                        Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                        If m_node.ChildNodes.Item(tmp_i).Name = "r" Then CurrentCondition.barometric.CurrentPressure = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "d" Then CurrentCondition.barometric.description = m_node.ChildNodes.Item(tmp_i).InnerText
                    Next
                Next

                Log("/weather/cc/wind")

                m_nodelist = m_xmld.SelectNodes("/weather/cc/wind")
                For Each m_node In m_nodelist
                    For tmp_i = 0 To m_node.ChildNodes.Count - 1
                        Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                        If m_node.ChildNodes.Item(tmp_i).Name = "d" Then CurrentCondition.TheWind.DirectionDegress = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "t" Then CurrentCondition.TheWind.Direction = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "gust" Then CurrentCondition.TheWind.gust = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "s" Then CurrentCondition.TheWind.Speed = m_node.ChildNodes.Item(tmp_i).InnerText
                    Next
                Next

                Log("/weather/cc/uv")

                m_nodelist = m_xmld.SelectNodes("/weather/cc/uv")
                For Each m_node In m_nodelist
                    For tmp_i = 0 To m_node.ChildNodes.Count - 1
                        Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                        If m_node.ChildNodes.Item(tmp_i).Name = "i" Then CurrentCondition.UVIndex.indexValue = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "t" Then CurrentCondition.UVIndex.description = m_node.ChildNodes.Item(tmp_i).InnerText
                    Next
                Next

                Log("/weather/cc/moon")

                m_nodelist = m_xmld.SelectNodes("/weather/cc/moon")
                For Each m_node In m_nodelist
                    For tmp_i = 0 To m_node.ChildNodes.Count - 1
                        Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                        If m_node.ChildNodes.Item(tmp_i).Name = "icon" Then CurrentCondition.TheMoon.IconCode = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "t" Then CurrentCondition.TheMoon.description = m_node.ChildNodes.Item(tmp_i).InnerText
                    Next
                Next


                'Get the list of name nodes for Day Weather
                'Loop through the nodes
                For dayfor = 0 To daycount - 1
                    Log("/weather/dayf/day[@d='" & dayfor & "']")

                    m_nodelist = m_xmld.SelectNodes("/weather/dayf/day[@d='" & dayfor & "']")
                    For Each m_node In m_nodelist
                        days(dayfor).TheDay = m_node.Attributes.GetNamedItem("t").Value

                        Log("The Day " & m_node.Attributes.GetNamedItem("t").Value)

                        days(dayfor).TheDate = m_node.Attributes.GetNamedItem("dt").Value

                        Log("The Date " & m_node.Attributes.GetNamedItem("t").Value)

                        For tmp_i = 0 To m_node.ChildNodes.Count - 1
                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "hi" Then days(dayfor).HighTmp = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "low" Then days(dayfor).LowTmp = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "sunr" Then days(dayfor).Sunrise = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "suns" Then days(dayfor).Sunset = m_node.ChildNodes.Item(tmp_i).InnerText
                        Next
                    Next

                    Log("/weather/dayf/day[@d='" & dayfor & "']/part[@p='d']")

                    m_nodelist = m_xmld.SelectNodes("/weather/dayf/day[@d='" & dayfor & "']/part[@p='d']")
                    For Each m_node In m_nodelist
                        For tmp_i = 0 To m_node.ChildNodes.Count - 1
                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "icon" Then days(dayfor).dayicon = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "t" Then days(dayfor).daycondition = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "ppcp" Then days(dayfor).dayprecipitation = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "bt" Then days(dayfor).Shortdaycondition = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "hmid" Then days(dayfor).DayHumidity = m_node.ChildNodes.Item(tmp_i).InnerText

                        Next
                    Next

                    Log("/weather/dayf/day[@d='" & dayfor & "']/part[@p='n']")

                    m_nodelist = m_xmld.SelectNodes("/weather/dayf/day[@d='" & dayfor & "']/part[@p='n']")
                    For Each m_node In m_nodelist
                        For tmp_i = 0 To m_node.ChildNodes.Count - 1
                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "icon" Then days(dayfor).nighticon = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "t" Then days(dayfor).nightcondition = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "ppcp" Then days(dayfor).nightprecipitation = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "bt" Then days(dayfor).ShortNightcondition = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "hmid" Then days(dayfor).NightHumidity = m_node.ChildNodes.Item(tmp_i).InnerText

                        Next
                    Next

                    Log("/weather/dayf/day[@d='" & dayfor & "']/part[@p='d']/wind")

                    m_nodelist = m_xmld.SelectNodes("/weather/dayf/day[@d='" & dayfor & "']/part[@p='d']/wind")
                    For Each m_node In m_nodelist
                        For tmp_i = 0 To m_node.ChildNodes.Count - 1
                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "d" Then days(dayfor).DayWind.DirectionDegress = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "t" Then days(dayfor).DayWind.Direction = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "gust" Then days(dayfor).DayWind.gust = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "s" Then days(dayfor).DayWind.Speed = m_node.ChildNodes.Item(tmp_i).InnerText

                        Next
                    Next

                    Log("/weather/dayf/day[@d='" & dayfor & "']/part[@p='n']/wind")

                    m_nodelist = m_xmld.SelectNodes("/weather/dayf/day[@d='" & dayfor & "']/part[@p='n']/wind")
                    For Each m_node In m_nodelist
                        For tmp_i = 0 To m_node.ChildNodes.Count - 1
                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "d" Then days(dayfor).NightWind.DirectionDegress = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "t" Then days(dayfor).NightWind.Direction = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "gust" Then days(dayfor).NightWind.gust = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "s" Then days(dayfor).NightWind.Speed = m_node.ChildNodes.Item(tmp_i).InnerText
                        Next
                    Next
                Next

                'Return all values to LCDStudio

                Log("Returning Values to LCDStudio")

                For dayfor = 0 To days.Length - 1

                    Log("Returning day" & dayfor)

                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".ForecastDay", TranslateString(days(dayfor).TheDay, WeatherSettings.Translation))

                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".ForecastHigh", days(dayfor).HighTmp)
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".ForecastLow", days(dayfor).LowTmp)

                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".ForecastSunrise", days(dayfor).Sunrise)
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".ForecastSunset", days(dayfor).Sunset)

                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Day.Condition", TranslateString(days(dayfor).daycondition, WeatherSettings.Translation))
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Day.Icon", days(dayfor).dayicon)
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Day.Precipitation", days(dayfor).dayprecipitation)
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Day.WindDirection", days(dayfor).DayWind.Direction)
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Day.WindDirectiondegress", days(dayfor).DayWind.DirectionDegress)
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Day.WindGust", days(dayfor).DayWind.gust)
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Day.WindSpeed", days(dayfor).DayWind.Speed)

                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Night.Condition", TranslateString(days(dayfor).nightcondition, WeatherSettings.Translation))
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Night.Icon", days(dayfor).nighticon)
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Night.Precipitation", days(dayfor).nightprecipitation)
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Night.WindDirection", days(dayfor).NightWind.Direction)
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Night.WindDirectiondegress", days(dayfor).NightWind.DirectionDegress)
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Night.WindGust", days(dayfor).NightWind.gust)
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Night.WindSpeed", days(dayfor).NightWind.Speed)

                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".ForecastDate", days(dayfor).TheDate)
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Day.ShortCondition", TranslateString(days(dayfor).Shortdaycondition, WeatherSettings.Translation))
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Night.ShortCondition", TranslateString(days(dayfor).ShortNightcondition, WeatherSettings.Translation))
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Day.Humidity", days(dayfor).DayHumidity)
                    ds.SetValue(KeyString & ".day" & Format(dayfor + 1, "00") & ".Night.Humidity", days(dayfor).NightHumidity)

                Next
                Log("Returning current conditions")
                ds.SetValue(KeyString & ".cc.Currenttemp", CurrentCondition.Currenttemp)

                ds.SetValue(KeyString & ".cc.TimeUpdated", CurrentCondition.Timeupdated)
                ds.SetValue(KeyString & ".cc.Condition", TranslateString(CurrentCondition.Condition, WeatherSettings.Translation))
                ds.SetValue(KeyString & ".cc.icon", CurrentCondition.IconCode)
                ds.SetValue(KeyString & ".cc.WindDirection", CurrentCondition.TheWind.Direction)
                ds.SetValue(KeyString & ".cc.WindDegrees", CurrentCondition.TheWind.DirectionDegress)
                ds.SetValue(KeyString & ".cc.gust", CurrentCondition.TheWind.gust)
                ds.SetValue(KeyString & ".cc.speed", CurrentCondition.TheWind.Speed)

                ds.SetValue(KeyString & ".cc.FeelsTemp", CurrentCondition.feelsTemp)
                ds.SetValue(KeyString & ".cc.Observation", CurrentCondition.observation)
                ds.SetValue(KeyString & ".cc.Humidity", CurrentCondition.humidity)
                ds.SetValue(KeyString & ".cc.Visibility", CurrentCondition.visibility)
                ds.SetValue(KeyString & ".cc.Dewpoint", CurrentCondition.DewPoint)

                ds.SetValue(KeyString & ".cc.barometricPressure", CurrentCondition.barometric.CurrentPressure)
                ds.SetValue(KeyString & ".cc.barometricDescription", TranslateString(CurrentCondition.barometric.description, WeatherSettings.Translation))
                ds.SetValue(KeyString & ".cc.uvindex", CurrentCondition.UVIndex.indexValue)
                ds.SetValue(KeyString & ".cc.UVdescription", TranslateString(CurrentCondition.UVIndex.description, WeatherSettings.Translation))
                ds.SetValue(KeyString & ".cc.Moonicon", CurrentCondition.TheMoon.IconCode)
                ds.SetValue(KeyString & ".cc.Moondescription", TranslateString(CurrentCondition.TheMoon.description, WeatherSettings.Translation))

                ds.SetValue(KeyString & ".Location", ForecastLocation)
                ds.SetValue(KeyString & ".URL", weatherURL)
                Log("Finished Returning Values to LCDStudio")

            End If
            working(LocFor) = True
            ds.SetValue(KeyString & ".LastError", Lasterror)
        Next
        ds.SetValue("weather.working", True)
        For tmp_work As Integer = 1 To working.Length - 1
            If working(tmp_work) = False Then ds.SetValue("weather.working", False)
        Next
        UseLog = False

        Log("Finished UpdateData")

    End Sub

#End Region

End Class