Imports System
Imports System.io
Imports System.Xml

Public Class Plugin
    Inherits LcdStudio.CoreInterfaces.AbstractDataPlugin

#Region "    GUI init     "
    Public Overrides ReadOnly Property Serializable() As Boolean
        Get
            Return True
        End Get
    End Property

    Public Overrides ReadOnly Property ConfigType() As Type
        Get
            Return GetType(WeatherSettings)
        End Get
    End Property

    Public Overrides ReadOnly Property ConfigPanel() As System.Windows.Forms.Control
        Get
            Return New GUISetting_Tab(CType(_settings, WeatherSettings))
        End Get
    End Property
#End Region

#Region "    Varibles     "

    Private TranslationArray1 As New ArrayList
    Private TranslationArray2 As New ArrayList
    Public Shared TranslationRead As Boolean = False
    Public Shared Group_ID As Integer

    'Private TranslationText As String
    Private ForecastLocation As String
    Private urlFound As Boolean = False
    Private weatherURL As String
    Private FormatURL As String
    Private SettingINI As String
    Private Lasterror As String
    Public Shared UseLog As Boolean

    Structure wind
        Public DirectionDegress As String
        Public Direction As String
        Public gust As String
        Public Speed As String
    End Structure

    Structure moon
        Public IconCode As String
        Public description As String
    End Structure

    Structure uv
        Public indexValue As String
        Public description As String
    End Structure

    Structure bar
        Public CurrentPressure As String
        Public description As String
    End Structure

    Structure cc
        Public Currenttemp As String
        Public feelsTemp As String
        Public Timeupdated As String
        Public Condition As String
        Public IconCode As String
        Public observation As String
        Public humidity As String
        Public visibility As String
        Public DewPoint As String

        Public TheWind As wind
        Public barometric As bar
        Public UVIndex As uv
        Public TheMoon As moon
    End Structure

    Structure day
        Public HighTmp As String
        Public LowTmp As String
        Public Sunrise As String
        Public Sunset As String
        Public TheDay As String
        Public TheDate As String
        Public dayicon As String
        Public daycondition As String
        Public Shortdaycondition As String
        Public dayprecipitation As String
        Public DayHumidity As String
        Public DayWind As wind
        Public nighticon As String
        Public nightcondition As String
        Public ShortNightcondition As String
        Public nightprecipitation As String
        Public NightHumidity As String
        Public NightWind As wind
    End Structure

    Private CurrentCondition As cc
    Private days() As day
    Public daycount As Integer
    Private sr As StreamReader
    Private strSearch As String
    Private StartPos1 As Integer
    Private StartPos2 As Integer
    Private LocationsID() As String

#End Region

#Region "    LCDStudio Plugin     "
    Public Overrides Sub RegisterData(ByVal ds As LcdStudio.CoreInterfaces.IDataService)
        Dim tmp_z As Integer
        Dim tmp_d As Integer

        Dim InitialSettings As WeatherSettings = CType(_settings, WeatherSettings)

        If InitialSettings.enablelog = "True" Then
            InitialSettings.enablelog = "False"
            UseLog = True
        End If

        Log("Starting RegisterData")
        If UseLog = True Then
            Log("Retrived Settings:" & vbCrLf & "Number of Days " & InitialSettings.NumDays & vbCrLf & "Temp Format " & InitialSettings.TempFormat & vbCrLf & "Translation File " & InitialSettings.Translation & vbCrLf & "Update Time " & InitialSettings.Updatetime & vbCrLf & "Weather ID " & InitialSettings.WeatherID)
        End If
        daycount = InitialSettings.NumDays
        If daycount = Nothing Then daycount = 5
        If InitialSettings.Updatetime = Nothing Then InitialSettings.Updatetime = "600000"
        ReDim days(daycount - 1)
        LocationsID = Split(InitialSettings.WeatherID, ",")
        'ReDim Preserve LocationsID(LocationsID.Length)
        If LocationsID.Length > 1 Then
            Log("Starting Multiple Locations Registers")
            For tmp_d = 1 To LocationsID.Length
                For tmp_z = 1 To days.Length
                    Log("Registering day" & tmp_z)
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".ForecastDay", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Forecast Day")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".ForecastHigh", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\High Temperature")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".ForecastLow", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Low Temperature")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".ForecastSunrise", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Sunrise")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".ForecastSunset", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Sunset")

                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Day.Condition", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Day\Forecast Condition")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Day.Icon", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Day\Forecast Icon")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Day.Precipitation", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Day\Precipitation")

                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Day.WindDirection", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Day\Wind Direction")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Day.WindDirectiondegress", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Day\Wind Direction in Degrees")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Day.WindGust", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Day\Maximum Wind Gust Speed")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Day.WindSpeed", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Day\Wind Speed")

                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Night.Condition", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Night\Forecast Condition")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Night.Icon", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Night\Forecast Icon")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Night.Precipitation", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Night\Precipitation")

                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Night.WindDirection", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Night\Wind Direction")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Night.WindDirectiondegress", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Night\Wind Direction in Degrees")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Night.WindGust", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Night\Maximum Wind Gust Speed")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Night.WindSpeed", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Night\Wind Speed")

                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".ForecastDate", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Forecast Date")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Day.ShortCondition", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Day\Short Forecast Condition")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Night.ShortCondition", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Night\Short Forecast Condition")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Day.Humidity", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Day\Humidity")
                    ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_z, "00") & ".Night.Humidity", "weather\location" & Format(tmp_d, "00") & "\day" & Format(tmp_z, "00") & "\Night\Humidity")

                Next
                Log("Starting cc Registers")

                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.TimeUpdated", "weather\location" & Format(tmp_d, "00") & "\cc\Time Updated")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.Currenttemp", "weather\location" & Format(tmp_d, "00") & "\cc\Current temperature")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.Condition", "weather\location" & Format(tmp_d, "00") & "\cc\Current Condition")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.icon", "weather\location" & Format(tmp_d, "00") & "\cc\Current Icon")

                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.WindDirection", "weather\location" & Format(tmp_d, "00") & "\cc\Wind Direction")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.WindDegrees", "weather\location" & Format(tmp_d, "00") & "\cc\Wind Direction in Degrees")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.gust", "weather\location" & Format(tmp_d, "00") & "\cc\Maximum Wind Gust Speed")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.speed", "weather\location" & Format(tmp_d, "00") & "\cc\Wind Speed")

                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.FeelsTemp", "weather\location" & Format(tmp_d, "00") & "\cc\Feels Like Temp")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.Observation", "weather\location" & Format(tmp_d, "00") & "\cc\Observation Station")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.Humidity", "weather\location" & Format(tmp_d, "00") & "\cc\Humidity")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.Visibility", "weather\location" & Format(tmp_d, "00") & "\cc\Visibility")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.Dewpoint", "weather\location" & Format(tmp_d, "00") & "\cc\Dew Point")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.barometricPressure", "weather\location" & Format(tmp_d, "00") & "\cc\Barometric Pressure")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.barometricDescription", "weather\location" & Format(tmp_d, "00") & "\cc\Barometric Description")

                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.uvindex", "weather\location" & Format(tmp_d, "00") & "\cc\UV Index")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.UVdescription", "weather\location" & Format(tmp_d, "00") & "\cc\UV Description")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.Moonicon", "weather\location" & Format(tmp_d, "00") & "\cc\Moon Icon Code")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".cc.Moondescription", "weather\location" & Format(tmp_d, "00") & "\cc\Moon Description")

                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".Location", "weather\location" & Format(tmp_d, "00") & "\Location")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".URL", "weather\location" & Format(tmp_d, "00") & "\URL")
                ds.RegisterVariable(Group, "weather.location" & Format(tmp_d, "00") & ".LastError", "weather\location" & Format(tmp_d, "00") & "\Last Error")
            Next
        Else
            Log("Starting Single Locations Registers")

            For tmp_z = 1 To days.Length
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".ForecastDay", "weather\day" & Format(tmp_z, "00") & "\Forecast Day")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".ForecastHigh", "weather\day" & Format(tmp_z, "00") & "\High Temperature")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".ForecastLow", "weather\day" & Format(tmp_z, "00") & "\Low Temperature")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".ForecastSunrise", "weather\day" & Format(tmp_z, "00") & "\Sunrise")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".ForecastSunset", "weather\day" & Format(tmp_z, "00") & "\Sunset")

                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Day.Condition", "weather\day" & Format(tmp_z, "00") & "\Day\Forecast Condition")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Day.Icon", "weather\day" & Format(tmp_z, "00") & "\Day\Forecast Icon")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Day.Precipitation", "weather\day" & Format(tmp_z, "00") & "\Day\Precipitation")

                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Day.WindDirection", "weather\day" & Format(tmp_z, "00") & "\Day\Wind Direction")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Day.WindDirectiondegress", "weather\day" & Format(tmp_z, "00") & "\Day\Wind Direction in Degrees")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Day.WindGust", "weather\day" & Format(tmp_z, "00") & "\Day\Maximum Wind Gust Speed")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Day.WindSpeed", "weather\day" & Format(tmp_z, "00") & "\Day\Wind Speed")

                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Night.Condition", "weather\day" & Format(tmp_z, "00") & "\Night\Forecast Condition")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Night.Icon", "weather\day" & Format(tmp_z, "00") & "\Night\Forecast Icon")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Night.Precipitation", "weather\day" & Format(tmp_z, "00") & "\Night\Precipitation")

                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Night.WindDirection", "weather\day" & Format(tmp_z, "00") & "\Night\Wind Direction")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Night.WindDirectiondegress", "weather\day" & Format(tmp_z, "00") & "\Night\Wind Direction in Degrees")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Night.WindGust", "weather\day" & Format(tmp_z, "00") & "\Night\Maximum Wind Gust Speed")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Night.WindSpeed", "weather\day" & Format(tmp_z, "00") & "\Night\Wind Speed")

                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".ForecastDate", "weather\day" & Format(tmp_z, "00") & "\Forecast Date")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Day.ShortCondition", "weather\day" & Format(tmp_z, "00") & "\Day\Short Forecast Condition")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Night.ShortCondition", "weather\day" & Format(tmp_z, "00") & "\Night\Short Forecast Condition")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Day.Humidity", "weather\day" & Format(tmp_z, "00") & "\Day\Humidity")
                ds.RegisterVariable(Group, "weather.day" & Format(tmp_z, "00") & ".Night.Humidity", "weather\day" & Format(tmp_z, "00") & "\Night\Humidity")

            Next
            Log("Starting cc Registers")
            ds.RegisterVariable(Group, "weather.cc.TimeUpdated", "weather\cc\Time Updated")
            ds.RegisterVariable(Group, "weather.cc.Currenttemp", "weather\cc\Current temperature")
            ds.RegisterVariable(Group, "weather.cc.Condition", "weather\cc\Current Condition")
            ds.RegisterVariable(Group, "weather.cc.icon", "weather\cc\Current Icon")

            ds.RegisterVariable(Group, "weather.cc.WindDirection", "weather\cc\Wind Direction")
            ds.RegisterVariable(Group, "weather.cc.WindDegrees", "weather\cc\Wind Direction in Degrees")
            ds.RegisterVariable(Group, "weather.cc.gust", "weather\cc\Maximum Wind Gust Speed")
            ds.RegisterVariable(Group, "weather.cc.WindIcon", "weather\cc\Wind Direction Icon")
            ds.RegisterVariable(Group, "weather.cc.WindForce", "weather\cc\Wind Force")
            ds.RegisterVariable(Group, "weather.cc.speed", "weather\cc\Wind Speed")

            ds.RegisterVariable(Group, "weather.cc.FeelsTemp", "weather\cc\Feels Like Temp")
            ds.RegisterVariable(Group, "weather.cc.Observation", "weather\cc\Observation Station")
            ds.RegisterVariable(Group, "weather.cc.Humidity", "weather\cc\Humidity")
            ds.RegisterVariable(Group, "weather.cc.Visibility", "weather\cc\Visibility")
            ds.RegisterVariable(Group, "weather.cc.Dewpoint", "weather\cc\Dew Point")
            ds.RegisterVariable(Group, "weather.cc.barometricPressure", "weather\cc\Barometric Pressure")
            ds.RegisterVariable(Group, "weather.cc.barometricDescription", "weather\cc\Barometric Description")

            ds.RegisterVariable(Group, "weather.cc.uvindex", "weather\cc\UV Index")
            ds.RegisterVariable(Group, "weather.cc.UVdescription", "weather\cc\UV Description")
            ds.RegisterVariable(Group, "weather.cc.Moonicon", "weather\cc\Moon Icon Code")
            ds.RegisterVariable(Group, "weather.cc.Moondescription", "weather\cc\Moon Description")

            ds.RegisterVariable(Group, "weather.Location", "weather\Location")
            ds.RegisterVariable(Group, "weather.URL", "weather\URL")
            ds.RegisterVariable(Group, "weather.LastError", "weather\Last Error")


        End If
        ds.RegisterVariable(Group, "weather.working", "weather\Working")
        Me.UpdateInterval = InitialSettings.Updatetime 'Update every 10000ms (10 sec)

    End Sub

    Public Overrides Sub UpdateData(ByVal ds As LcdStudio.CoreInterfaces.IDataService)

        Dim tmp_i As Integer
        Dim virginHTML As String

        Dim tmp_n As Integer
        ds.SetValue("weather.working", False)

        Log("Starting Update Data")

        Dim WeatherSettings As WeatherSettings = CType(_settings, WeatherSettings)

        If UseLog = True Then
            Log("Retrived Settings:" & vbCrLf & "Number of Days " & WeatherSettings.NumDays & vbCrLf & "Temp Format " & WeatherSettings.TempFormat & vbCrLf & "Translation File " & WeatherSettings.Translation & vbCrLf & "Update Time " & WeatherSettings.Updatetime & vbCrLf & "Weather ID " & WeatherSettings.WeatherID)
        End If

        Select Case UCase(WeatherSettings.TempFormat)
            Case "A"
                FormatURL = "&unit=s"
            Case "M"
                FormatURL = "&unit=m"
            Case "E"
                FormatURL = "&unit=s&ut=C"
            Case Else
                FormatURL = WeatherSettings.TempFormat
        End Select


        If LocationsID.Length > 1 Then
            Log("Starting Multiple Locations UpdateData")
            Dim working(LocationsID.Length) As Boolean

            For tmp_d As Integer = 1 To LocationsID.Length

                working(tmp_d) = False

                weatherURL = Nothing
                virginHTML = Nothing
                tmp_i = Nothing
                tmp_n = Nothing
                ReDim days(daycount - 1)
                CurrentCondition = Nothing
                Lasterror = Nothing

                weatherURL = "http://xoap.weather.com/weather/local/" & LocationsID(tmp_d - 1) & "?cc=*&dayf=" & daycount & FormatURL
                Log("URL " & weatherURL)
                virginHTML = GetPageHTML(weatherURL, 5, WeatherSettings.proxy, Lasterror, True)
                Log(virginHTML)

                If virginHTML <> "" Then

                    Log("Starting XML Reading")

                    Dim m_xmld As XmlDocument = Nothing
                    Dim m_nodelist As XmlNodeList = Nothing
                    Dim m_node As XmlNode = Nothing

                    m_xmld = New XmlDocument
                    'Load the Xml file
                    m_xmld.LoadXml(virginHTML)

                    Log("/weather/loc")
                    'Get the list of name nodes for loc
                    m_nodelist = m_xmld.SelectNodes("/weather/loc")
                    'Loop through the nodes
                    For Each m_node In m_nodelist
                        'Get the Gender Attribute Value
                        Dim idAttribute As String = m_node.Attributes.GetNamedItem("id").Value

                        Log("XML ID " & idAttribute)

                        For tmp_i = 0 To m_node.ChildNodes.Count - 1

                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "dnam" Then
                                ForecastLocation = m_node.ChildNodes.Item(tmp_i).InnerText
                                Exit For
                            End If
                        Next
                    Next

                    Log("/weather/cc")
                    'Get the list of name nodes for Current Condition
                    m_nodelist = m_xmld.SelectNodes("/weather/cc")
                    'Loop through the nodes
                    For Each m_node In m_nodelist
                        'Get the Gender Attribute Value
                        For tmp_i = 0 To m_node.ChildNodes.Count - 1
                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "lsup" Then CurrentCondition.Timeupdated = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "tmp" Then CurrentCondition.Currenttemp = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "t" Then CurrentCondition.Condition = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "icon" Then CurrentCondition.IconCode = m_node.ChildNodes.Item(tmp_i).InnerText

                            If m_node.ChildNodes.Item(tmp_i).Name = "flik" Then CurrentCondition.feelsTemp = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "obst" Then CurrentCondition.observation = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "hmid" Then CurrentCondition.humidity = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "vis" Then CurrentCondition.visibility = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "dewp" Then CurrentCondition.DewPoint = m_node.ChildNodes.Item(tmp_i).InnerText
                        Next
                    Next

                    Log("/Weather/cc/bar")

                    m_nodelist = m_xmld.SelectNodes("/weather/cc/bar")
                    For Each m_node In m_nodelist
                        For tmp_i = 0 To m_node.ChildNodes.Count - 1
                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "r" Then CurrentCondition.barometric.CurrentPressure = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "d" Then CurrentCondition.barometric.description = m_node.ChildNodes.Item(tmp_i).InnerText
                        Next
                    Next

                    Log("/weather/cc/wind")

                    m_nodelist = m_xmld.SelectNodes("/weather/cc/wind")
                    For Each m_node In m_nodelist
                        For tmp_i = 0 To m_node.ChildNodes.Count - 1
                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "d" Then CurrentCondition.TheWind.DirectionDegress = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "t" Then CurrentCondition.TheWind.Direction = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "gust" Then CurrentCondition.TheWind.gust = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "s" Then CurrentCondition.TheWind.Speed = m_node.ChildNodes.Item(tmp_i).InnerText
                        Next
                    Next

                    Log("/weather/cc/uv")

                    m_nodelist = m_xmld.SelectNodes("/weather/cc/uv")
                    For Each m_node In m_nodelist
                        For tmp_i = 0 To m_node.ChildNodes.Count - 1
                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "i" Then CurrentCondition.UVIndex.indexValue = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "t" Then CurrentCondition.UVIndex.description = m_node.ChildNodes.Item(tmp_i).InnerText
                        Next
                    Next

                    Log("/weather/cc/moon")

                    m_nodelist = m_xmld.SelectNodes("/weather/cc/moon")
                    For Each m_node In m_nodelist
                        For tmp_i = 0 To m_node.ChildNodes.Count - 1
                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "icon" Then CurrentCondition.TheMoon.IconCode = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "t" Then CurrentCondition.TheMoon.description = m_node.ChildNodes.Item(tmp_i).InnerText
                        Next
                    Next


                    'Get the list of name nodes for Day Weather
                    'Loop through the nodes
                    For tmp_n = 0 To daycount - 1
                        Log("/weather/dayf/day[@d='" & tmp_n & "']")

                        m_nodelist = m_xmld.SelectNodes("/weather/dayf/day[@d='" & tmp_n & "']")
                        For Each m_node In m_nodelist
                            days(tmp_n).TheDay = m_node.Attributes.GetNamedItem("t").Value

                            Log("The Day " & m_node.Attributes.GetNamedItem("t").Value)

                            days(tmp_n).TheDate = m_node.Attributes.GetNamedItem("dt").Value

                            Log("The Date " & m_node.Attributes.GetNamedItem("t").Value)

                            For tmp_i = 0 To m_node.ChildNodes.Count - 1
                                Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                                If m_node.ChildNodes.Item(tmp_i).Name = "hi" Then days(tmp_n).HighTmp = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "low" Then days(tmp_n).LowTmp = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "sunr" Then days(tmp_n).Sunrise = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "suns" Then days(tmp_n).Sunset = m_node.ChildNodes.Item(tmp_i).InnerText
                            Next
                        Next

                        Log("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='d']")

                        m_nodelist = m_xmld.SelectNodes("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='d']")
                        For Each m_node In m_nodelist
                            For tmp_i = 0 To m_node.ChildNodes.Count - 1
                                Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                                If m_node.ChildNodes.Item(tmp_i).Name = "icon" Then days(tmp_n).dayicon = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "t" Then days(tmp_n).daycondition = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "ppcp" Then days(tmp_n).dayprecipitation = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "bt" Then days(tmp_n).Shortdaycondition = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "hmid" Then days(tmp_n).DayHumidity = m_node.ChildNodes.Item(tmp_i).InnerText

                            Next
                        Next

                        Log("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='n']")

                        m_nodelist = m_xmld.SelectNodes("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='n']")
                        For Each m_node In m_nodelist
                            For tmp_i = 0 To m_node.ChildNodes.Count - 1
                                Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                                If m_node.ChildNodes.Item(tmp_i).Name = "icon" Then days(tmp_n).nighticon = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "t" Then days(tmp_n).nightcondition = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "ppcp" Then days(tmp_n).nightprecipitation = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "bt" Then days(tmp_n).ShortNightcondition = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "hmid" Then days(tmp_n).NightHumidity = m_node.ChildNodes.Item(tmp_i).InnerText

                            Next
                        Next

                        Log("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='d']/wind")

                        m_nodelist = m_xmld.SelectNodes("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='d']/wind")
                        For Each m_node In m_nodelist
                            For tmp_i = 0 To m_node.ChildNodes.Count - 1
                                Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                                If m_node.ChildNodes.Item(tmp_i).Name = "d" Then days(tmp_n).DayWind.DirectionDegress = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "t" Then days(tmp_n).DayWind.Direction = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "gust" Then days(tmp_n).DayWind.gust = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "s" Then days(tmp_n).DayWind.Speed = m_node.ChildNodes.Item(tmp_i).InnerText

                            Next
                        Next

                        Log("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='n']/wind")

                        m_nodelist = m_xmld.SelectNodes("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='n']/wind")
                        For Each m_node In m_nodelist
                            For tmp_i = 0 To m_node.ChildNodes.Count - 1
                                Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                                If m_node.ChildNodes.Item(tmp_i).Name = "d" Then days(tmp_n).NightWind.DirectionDegress = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "t" Then days(tmp_n).NightWind.Direction = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "gust" Then days(tmp_n).NightWind.gust = m_node.ChildNodes.Item(tmp_i).InnerText
                                If m_node.ChildNodes.Item(tmp_i).Name = "s" Then days(tmp_n).NightWind.Speed = m_node.ChildNodes.Item(tmp_i).InnerText
                            Next
                        Next
                    Next

                    'Return all values to LCDStudio

                    Log("Returning Values to LCDStudio")

                    For tmp_i = 0 To days.Length - 1

                        Log("Returning day" & tmp_i)

                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".ForecastDay", TranslateString(days(tmp_i).TheDay, WeatherSettings.Translation))

                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".ForecastHigh", days(tmp_i).HighTmp)
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".ForecastLow", days(tmp_i).LowTmp)

                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".ForecastSunrise", days(tmp_i).Sunrise)
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".ForecastSunset", days(tmp_i).Sunset)

                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Day.Condition", TranslateString(days(tmp_i).daycondition, WeatherSettings.Translation))
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Day.Icon", days(tmp_i).dayicon)
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Day.Precipitation", days(tmp_i).dayprecipitation)
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Day.WindDirection", days(tmp_i).DayWind.Direction)
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Day.WindDirectiondegress", days(tmp_i).DayWind.DirectionDegress)
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Day.WindGust", days(tmp_i).DayWind.gust)
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Day.WindSpeed", days(tmp_i).DayWind.Speed)

                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Night.Condition", TranslateString(days(tmp_i).nightcondition, WeatherSettings.Translation))
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Night.Icon", days(tmp_i).nighticon)
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Night.Precipitation", days(tmp_i).nightprecipitation)
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Night.WindDirection", days(tmp_i).NightWind.Direction)
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Night.WindDirectiondegress", days(tmp_i).NightWind.DirectionDegress)
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Night.WindGust", days(tmp_i).NightWind.gust)
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Night.WindSpeed", days(tmp_i).NightWind.Speed)

                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".ForecastDate", days(tmp_i).TheDate)
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Day.ShortCondition", TranslateString(days(tmp_i).Shortdaycondition, WeatherSettings.Translation))
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Night.ShortCondition", TranslateString(days(tmp_i).ShortNightcondition, WeatherSettings.Translation))
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Day.Humidity", days(tmp_i).DayHumidity)
                        ds.SetValue("weather.location" & Format(tmp_d, "00") & ".day" & Format(tmp_i + 1, "00") & ".Night.Humidity", days(tmp_i).NightHumidity)

                    Next
                    Log("Returning current conditions")
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.Currenttemp", CurrentCondition.Currenttemp)

                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.TimeUpdated", CurrentCondition.Timeupdated)
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.Condition", TranslateString(CurrentCondition.Condition, WeatherSettings.Translation))
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.icon", CurrentCondition.IconCode)
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.WindDirection", CurrentCondition.TheWind.Direction)
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.WindDegrees", CurrentCondition.TheWind.DirectionDegress)
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.gust", CurrentCondition.TheWind.gust)
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.speed", CurrentCondition.TheWind.Speed)

                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.FeelsTemp", CurrentCondition.feelsTemp)
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.Observation", CurrentCondition.observation)
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.Humidity", CurrentCondition.humidity)
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.Visibility", CurrentCondition.visibility)
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.Dewpoint", CurrentCondition.DewPoint)

                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.barometricPressure", CurrentCondition.barometric.CurrentPressure)
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.barometricDescription", TranslateString(CurrentCondition.barometric.description, WeatherSettings.Translation))
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.uvindex", CurrentCondition.UVIndex.indexValue)
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.UVdescription", TranslateString(CurrentCondition.UVIndex.description, WeatherSettings.Translation))
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.Moonicon", CurrentCondition.TheMoon.IconCode)
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".cc.Moondescription", TranslateString(CurrentCondition.TheMoon.description, WeatherSettings.Translation))

                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".Location", ForecastLocation)
                    ds.SetValue("weather.location" & Format(tmp_d, "00") & ".URL", weatherURL)
                    Log("Finished Returning Values to LCDStudio")

                End If
                working(tmp_d) = True
                ds.SetValue("weather.location" & Format(tmp_d, "00") & ".LastError", Lasterror)
            Next
            ds.SetValue("weather.working", True)
            For tmp_work As Integer = 1 To working.Length - 1
                If working(tmp_work) = False Then ds.SetValue("weather.working", False)
            Next

        Else
            Log("Starting Single Location UpdateData")

            ds.SetValue("weather.working", False)

            weatherURL = "http://xoap.weather.com/weather/local/" & WeatherSettings.WeatherID & "?cc=*&dayf=" & daycount & FormatURL
            Log("URL " & weatherURL)
            virginHTML = GetPageHTML(weatherURL, 5, WeatherSettings.proxy, Lasterror, True)
            Log(virginHTML)

            If virginHTML <> "" Then
                Log("Starting XML Reading")
                Dim m_xmld As XmlDocument
                Dim m_nodelist As XmlNodeList
                Dim m_node As XmlNode

                m_xmld = New XmlDocument
                'Load the Xml file
                m_xmld.LoadXml(virginHTML)

                Log("/weather/loc")
                'Get the list of name nodes for loc
                m_nodelist = m_xmld.SelectNodes("/weather/loc")
                'Loop through the nodes
                For Each m_node In m_nodelist
                    'Get the Gender Attribute Value
                    Dim idAttribute As String = m_node.Attributes.GetNamedItem("id").Value

                    Log("XML ID " & idAttribute)

                    For tmp_i = 0 To m_node.ChildNodes.Count - 1

                        Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                        If m_node.ChildNodes.Item(tmp_i).Name = "dnam" Then
                            ForecastLocation = m_node.ChildNodes.Item(tmp_i).InnerText
                            Exit For
                        End If
                    Next
                Next

                Log("/weather/cc")
                'Get the list of name nodes for Current Condition
                m_nodelist = m_xmld.SelectNodes("/weather/cc")
                'Loop through the nodes
                For Each m_node In m_nodelist
                    'Get the Gender Attribute Value
                    For tmp_i = 0 To m_node.ChildNodes.Count - 1
                        Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                        If m_node.ChildNodes.Item(tmp_i).Name = "lsup" Then CurrentCondition.Timeupdated = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "tmp" Then CurrentCondition.Currenttemp = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "t" Then CurrentCondition.Condition = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "icon" Then CurrentCondition.IconCode = m_node.ChildNodes.Item(tmp_i).InnerText

                        If m_node.ChildNodes.Item(tmp_i).Name = "flik" Then CurrentCondition.feelsTemp = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "obst" Then CurrentCondition.observation = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "hmid" Then CurrentCondition.humidity = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "vis" Then CurrentCondition.visibility = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "dewp" Then CurrentCondition.DewPoint = m_node.ChildNodes.Item(tmp_i).InnerText
                    Next
                Next

                Log("/Weather/cc/bar")
                m_nodelist = m_xmld.SelectNodes("/weather/cc/bar")
                For Each m_node In m_nodelist
                    For tmp_i = 0 To m_node.ChildNodes.Count - 1
                        Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                        If m_node.ChildNodes.Item(tmp_i).Name = "r" Then CurrentCondition.barometric.CurrentPressure = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "d" Then CurrentCondition.barometric.description = m_node.ChildNodes.Item(tmp_i).InnerText
                    Next
                Next

                Log("/weather/cc/wind")
                m_nodelist = m_xmld.SelectNodes("/weather/cc/wind")
                For Each m_node In m_nodelist
                    For tmp_i = 0 To m_node.ChildNodes.Count - 1
                        Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                        If m_node.ChildNodes.Item(tmp_i).Name = "d" Then CurrentCondition.TheWind.DirectionDegress = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "t" Then CurrentCondition.TheWind.Direction = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "gust" Then CurrentCondition.TheWind.gust = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "s" Then CurrentCondition.TheWind.Speed = m_node.ChildNodes.Item(tmp_i).InnerText
                    Next
                Next

                Log("/weather/cc/uv")
                m_nodelist = m_xmld.SelectNodes("/weather/cc/uv")
                For Each m_node In m_nodelist
                    For tmp_i = 0 To m_node.ChildNodes.Count - 1
                        Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                        If m_node.ChildNodes.Item(tmp_i).Name = "i" Then CurrentCondition.UVIndex.indexValue = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "t" Then CurrentCondition.UVIndex.description = m_node.ChildNodes.Item(tmp_i).InnerText
                    Next
                Next

                Log("/weather/cc/moon")
                m_nodelist = m_xmld.SelectNodes("/weather/cc/moon")
                For Each m_node In m_nodelist
                    For tmp_i = 0 To m_node.ChildNodes.Count - 1
                        Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                        If m_node.ChildNodes.Item(tmp_i).Name = "icon" Then CurrentCondition.TheMoon.IconCode = m_node.ChildNodes.Item(tmp_i).InnerText
                        If m_node.ChildNodes.Item(tmp_i).Name = "t" Then CurrentCondition.TheMoon.description = m_node.ChildNodes.Item(tmp_i).InnerText
                    Next
                Next


                'Get the list of name nodes for Day Weather
                'Loop through the nodes
                For tmp_n = 0 To daycount - 1
                    Log("/weather/dayf/day[@d='" & tmp_n & "']")

                    m_nodelist = m_xmld.SelectNodes("/weather/dayf/day[@d='" & tmp_n & "']")
                    For Each m_node In m_nodelist
                        days(tmp_n).TheDay = m_node.Attributes.GetNamedItem("t").Value
                        Log("The Day " & m_node.Attributes.GetNamedItem("t").Value)
                        days(tmp_n).TheDate = m_node.Attributes.GetNamedItem("dt").Value
                        Log("The Date " & m_node.Attributes.GetNamedItem("t").Value)

                        For tmp_i = 0 To m_node.ChildNodes.Count - 1
                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "hi" Then days(tmp_n).HighTmp = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "low" Then days(tmp_n).LowTmp = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "sunr" Then days(tmp_n).Sunrise = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "suns" Then days(tmp_n).Sunset = m_node.ChildNodes.Item(tmp_i).InnerText
                        Next
                    Next

                    Log("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='d']")

                    m_nodelist = m_xmld.SelectNodes("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='d']")
                    For Each m_node In m_nodelist
                        For tmp_i = 0 To m_node.ChildNodes.Count - 1
                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "icon" Then days(tmp_n).dayicon = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "t" Then days(tmp_n).daycondition = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "ppcp" Then days(tmp_n).dayprecipitation = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "bt" Then days(tmp_n).Shortdaycondition = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "hmid" Then days(tmp_n).DayHumidity = m_node.ChildNodes.Item(tmp_i).InnerText

                        Next
                    Next

                    Log("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='n']")
                    m_nodelist = m_xmld.SelectNodes("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='n']")
                    For Each m_node In m_nodelist
                        For tmp_i = 0 To m_node.ChildNodes.Count - 1
                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "icon" Then days(tmp_n).nighticon = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "t" Then days(tmp_n).nightcondition = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "ppcp" Then days(tmp_n).nightprecipitation = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "bt" Then days(tmp_n).ShortNightcondition = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "hmid" Then days(tmp_n).NightHumidity = m_node.ChildNodes.Item(tmp_i).InnerText

                        Next
                    Next

                    Log("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='d']/wind")
                    m_nodelist = m_xmld.SelectNodes("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='d']/wind")
                    For Each m_node In m_nodelist
                        For tmp_i = 0 To m_node.ChildNodes.Count - 1
                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "d" Then days(tmp_n).DayWind.DirectionDegress = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "t" Then days(tmp_n).DayWind.Direction = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "gust" Then days(tmp_n).DayWind.gust = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "s" Then days(tmp_n).DayWind.Speed = m_node.ChildNodes.Item(tmp_i).InnerText

                        Next
                    Next

                    Log("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='n']/wind")
                    m_nodelist = m_xmld.SelectNodes("/weather/dayf/day[@d='" & tmp_n & "']/part[@p='n']/wind")
                    For Each m_node In m_nodelist
                        For tmp_i = 0 To m_node.ChildNodes.Count - 1
                            Log("Childnode " & tmp_i & "=" & m_node.ChildNodes.Item(tmp_i).Name & "=" & m_node.ChildNodes.Item(tmp_i).InnerText)

                            If m_node.ChildNodes.Item(tmp_i).Name = "d" Then days(tmp_n).NightWind.DirectionDegress = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "t" Then days(tmp_n).NightWind.Direction = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "gust" Then days(tmp_n).NightWind.gust = m_node.ChildNodes.Item(tmp_i).InnerText
                            If m_node.ChildNodes.Item(tmp_i).Name = "s" Then days(tmp_n).NightWind.Speed = m_node.ChildNodes.Item(tmp_i).InnerText
                        Next
                    Next
                Next

                'Return all values to LCDStudio
                Log("Returning Values to LCDStudio")

                For tmp_i = 0 To days.Length - 1
                    Log("Returning day" & tmp_i)
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".ForecastDay", TranslateString(days(tmp_i).TheDay, WeatherSettings.Translation))

                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".ForecastHigh", days(tmp_i).HighTmp)
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".ForecastLow", days(tmp_i).LowTmp)

                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".ForecastSunrise", days(tmp_i).Sunrise)
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".ForecastSunset", days(tmp_i).Sunset)

                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Day.Condition", TranslateString(days(tmp_i).daycondition, WeatherSettings.Translation))
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Day.Icon", days(tmp_i).dayicon)
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Day.Precipitation", days(tmp_i).dayprecipitation)
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Day.WindDirection", days(tmp_i).DayWind.Direction)
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Day.WindDirectiondegress", days(tmp_i).DayWind.DirectionDegress)
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Day.WindGust", days(tmp_i).DayWind.gust)
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Day.WindSpeed", days(tmp_i).DayWind.Speed)

                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Night.Condition", TranslateString(days(tmp_i).nightcondition, WeatherSettings.Translation))
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Night.Icon", days(tmp_i).nighticon)
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Night.Precipitation", days(tmp_i).nightprecipitation)
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Night.WindDirection", days(tmp_i).NightWind.Direction)
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Night.WindDirectiondegress", days(tmp_i).NightWind.DirectionDegress)
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Night.WindGust", days(tmp_i).NightWind.gust)
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Night.WindSpeed", days(tmp_i).NightWind.Speed)

                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".ForecastDate", days(tmp_i).TheDate)
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Day.ShortCondition", TranslateString(days(tmp_i).Shortdaycondition, WeatherSettings.Translation))
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Night.ShortCondition", TranslateString(days(tmp_i).ShortNightcondition, WeatherSettings.Translation))
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Day.Humidity", days(tmp_i).DayHumidity)
                    ds.SetValue("weather.day" & Format(tmp_i + 1, "00") & ".Night.Humidity", days(tmp_i).NightHumidity)

                Next
                Log("Returning current conditions")
                ds.SetValue("weather.cc.Currenttemp", CurrentCondition.Currenttemp)

                ds.SetValue("weather.cc.TimeUpdated", CurrentCondition.Timeupdated)
                ds.SetValue("weather.cc.Condition", TranslateString(CurrentCondition.Condition, WeatherSettings.Translation))
                ds.SetValue("weather.cc.icon", CurrentCondition.IconCode)
                ds.SetValue("weather.cc.WindDirection", CurrentCondition.TheWind.Direction)

                ds.SetValue("weather.cc.WindDegrees", CurrentCondition.TheWind.DirectionDegress)
                ds.SetValue("weather.cc.gust", CurrentCondition.TheWind.gust)
                ds.SetValue("weather.cc.speed", CurrentCondition.TheWind.Speed)
                ds.SetValue("weather.cc.WindIcon", CustomWind(CurrentCondition.TheWind.Direction))
                ds.SetValue("weather.cc.WindForce", CustomForce(CurrentCondition.TheWind.Speed))

                ds.SetValue("weather.cc.FeelsTemp", CurrentCondition.feelsTemp)
                ds.SetValue("weather.cc.Observation", CurrentCondition.observation)
                ds.SetValue("weather.cc.Humidity", CurrentCondition.humidity)
                ds.SetValue("weather.cc.Visibility", CurrentCondition.visibility)
                ds.SetValue("weather.cc.Dewpoint", CurrentCondition.DewPoint)

                ds.SetValue("weather.cc.barometricPressure", CurrentCondition.barometric.CurrentPressure)
                ds.SetValue("weather.cc.barometricDescription", TranslateString(CurrentCondition.barometric.description, WeatherSettings.Translation))
                ds.SetValue("weather.cc.uvindex", CurrentCondition.UVIndex.indexValue)
                ds.SetValue("weather.cc.UVdescription", TranslateString(CurrentCondition.UVIndex.description, WeatherSettings.Translation))
                ds.SetValue("weather.cc.Moonicon", CurrentCondition.TheMoon.IconCode)
                ds.SetValue("weather.cc.Moondescription", TranslateString(CurrentCondition.TheMoon.description, WeatherSettings.Translation))

                ds.SetValue("weather.Location", ForecastLocation)
                ds.SetValue("weather.URL", weatherURL)
                ds.SetValue("weather.working", True)

                Log("Finished Returning Values to LCDStudio")
            End If
            ds.SetValue("weather.LastError", Lasterror)

        End If
        UseLog = False

        Log("Finished UpdateData")

    End Sub

#End Region

End Class