Imports System.IO
Imports Weather.vbAccelerator.Controls.ListBar

Public Class GUISetting
    Inherits System.Windows.Forms.UserControl
    Private _settings As WeatherSettings ' = Nothing
    'Public Shared ArraySelection As Integer
    'Public Shared LocationString(1) As String
    Public Shared LocationIDString As String
    Public AdSett(5) As String

#Region " Windows Form Designer generated code "

    Public Sub New(ByVal settings As WeatherSettings)
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()
        _settings = settings
        Me.SetStyle(Windows.Forms.ControlStyles.SupportsTransparentBackColor, True)
        Me.BackColor = System.Drawing.Color.Transparent

        ToolTip1.SetToolTip(DaysUpDown, "Total number of days to retrieve from Weather.com (Maximum is 10 days)" & vbCrLf & "Changes only applied at restart")
        ToolTip1.SetToolTip(DaysLbl, "Total number of days to retrieve from Weather.com (Maximum is 10 days)" & vbCrLf & "Changes only applied at restart")
        ToolTip1.SetToolTip(TimeUpDown, "Time in ms that weather.com data is retrieved (Minimum is 1 second & Maximum is 24 hours)" & vbCrLf & "Changes only applied at restart")
        ToolTip1.SetToolTip(TimeLbl, "Time in ms that weather.com data is retrieved (Minimum is 1 second & Maximum is 24 hours)" & vbCrLf & "Changes only applied at restart")
        ToolTip1.SetToolTip(IDtxt, "Weather.com Location ID" & vbCrLf & "For multiple Locations seperate using a comma (,)")
        ToolTip1.SetToolTip(LogChk, "Enable's Log Creation for Debuging purposes" & vbCrLf & "Only logs one retreival at startup")
        'ToolTip1.SetToolTip(CustomTxt, "Changes only applied at restart")

        formCBox.Items.Add("SHORT")
        formCBox.Items.Add("MEDIUM")
        formCBox.Items.Add("LONG")

        utCBox.Items.Add("C")
        utCBox.Items.Add("F")

        udCBox.Items.Add("km")
        udCBox.Items.Add("mi")

        usCBox.Items.Add("km/h")
        usCBox.Items.Add("mph")

        upCBox.Items.Add("mb")
        upCBox.Items.Add("in")

        urCBox.Items.Add("mm")
        urCBox.Items.Add("in")

        If _settings.WeatherID = Nothing Then
            _settings.WeatherID = "USIL0225"
        End If
        If _settings.TempFormat = Nothing Then
            _settings.TempFormat = "A"
        End If
        If _settings.Updatetime = Nothing Then
            _settings.Updatetime = "600000"
        End If
        If _settings.NumDays = Nothing Then
            _settings.NumDays = "5"
        End If

        IDtxt.Text = settings.WeatherID
        TimeUpDown.Value = settings.Updatetime
        DaysUpDown.Value = settings.NumDays

        If settings.enablelog = "True" Then
            LogChk.Checked = True
        Else
            LogChk.Checked = False
        End If

        Select Case UCase(settings.TempFormat)
            Case "A"
                AmericanBtn.Checked = True
                EnglishBtn.Checked = False
                MetricBtn.Checked = False
                AdvanceGB.Visible = False
            Case "E"
                EnglishBtn.Checked = True
                AmericanBtn.Checked = False
                MetricBtn.Checked = False
                AdvanceGB.Visible = False
            Case "M"
                MetricBtn.Checked = True
                AmericanBtn.Checked = False
                EnglishBtn.Checked = False
                AdvanceGB.Visible = False
            Case Else
                CustomBtn.Checked = True
                MetricBtn.Checked = False
                AmericanBtn.Checked = False
                EnglishBtn.Checked = False
                AdvanceGB.Visible = True
                If Not settings.TempFormat = "" Then
                    AdvancedSettings(settings.TempFormat)
                Else
                    AmericanBtn.Checked = True
                    EnglishBtn.Checked = False
                    MetricBtn.Checked = False
                    AdvanceGB.Visible = False
                End If
        End Select
        TranslationTxt.Text = settings.Translation
        'OptionsBar.BackColor = Me.BackColor        'Populate ComboBox's
    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip
    Friend WithEvents OpenFileDialog1 As System.Windows.Forms.OpenFileDialog
    Friend WithEvents Button1 As System.Windows.Forms.Button
    Friend WithEvents Button2 As System.Windows.Forms.Button
    Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
    Friend WithEvents AdvanceGB As System.Windows.Forms.GroupBox
    Friend WithEvents DaysUpDown As System.Windows.Forms.NumericUpDown
    Friend WithEvents TimeUpDown As System.Windows.Forms.NumericUpDown
    Friend WithEvents BrowseBtn As System.Windows.Forms.Button
    Friend WithEvents TranslationTxt As System.Windows.Forms.TextBox
    Friend WithEvents IDtxt As System.Windows.Forms.TextBox
    Friend WithEvents label1 As System.Windows.Forms.Label
    Friend WithEvents CustomTxt As System.Windows.Forms.TextBox
    Friend WithEvents urCBox As System.Windows.Forms.ComboBox
    Friend WithEvents upCBox As System.Windows.Forms.ComboBox
    Friend WithEvents usCBox As System.Windows.Forms.ComboBox
    Friend WithEvents formCBox As System.Windows.Forms.ComboBox
    Friend WithEvents udCBox As System.Windows.Forms.ComboBox
    Friend WithEvents utCBox As System.Windows.Forms.ComboBox
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents Label6 As System.Windows.Forms.Label
    Friend WithEvents Label7 As System.Windows.Forms.Label
    Friend WithEvents Label8 As System.Windows.Forms.Label
    Friend WithEvents Label9 As System.Windows.Forms.Label
    Friend WithEvents SearchBTN As System.Windows.Forms.Button
    Friend WithEvents Label10 As System.Windows.Forms.Label
    Friend WithEvents ClearBtn As System.Windows.Forms.Button
    Friend WithEvents LogChk As System.Windows.Forms.CheckBox
    Friend WithEvents TimeLbl As System.Windows.Forms.Label
    Friend WithEvents DaysLbl As System.Windows.Forms.Label
    Friend WithEvents CustomPnl As System.Windows.Forms.Panel
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents Label11 As System.Windows.Forms.Label
    Friend WithEvents Label12 As System.Windows.Forms.Label
    Friend WithEvents Label13 As System.Windows.Forms.Label
    Friend WithEvents Label14 As System.Windows.Forms.Label
    Friend WithEvents ComboBox1 As System.Windows.Forms.ComboBox
    Friend WithEvents ComboBox2 As System.Windows.Forms.ComboBox
    Friend WithEvents ComboBox3 As System.Windows.Forms.ComboBox
    Friend WithEvents ComboBox4 As System.Windows.Forms.ComboBox
    Friend WithEvents ComboBox5 As System.Windows.Forms.ComboBox
    Friend WithEvents ComboBox6 As System.Windows.Forms.ComboBox
    Friend WithEvents TextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents Button3 As System.Windows.Forms.Button
    Friend WithEvents Button4 As System.Windows.Forms.Button
    Friend WithEvents Label15 As System.Windows.Forms.Label
    Friend WithEvents AmericanBtn As System.Windows.Forms.RadioButton
    Friend WithEvents CustomBtn As System.Windows.Forms.RadioButton
    Friend WithEvents MetricBtn As System.Windows.Forms.RadioButton
    Friend WithEvents EnglishBtn As System.Windows.Forms.RadioButton
    Friend WithEvents OptionsBar As Weather.vbAccelerator.Controls.ListBar.ButtonListBar
    Friend WithEvents BarIcons As System.Windows.Forms.ImageList
    Friend WithEvents Label16 As System.Windows.Forms.Label
    Friend WithEvents Button5 As System.Windows.Forms.Button
    Friend WithEvents Button6 As System.Windows.Forms.Button
    Friend WithEvents RadioButton1 As System.Windows.Forms.RadioButton
    Friend WithEvents RadioButton2 As System.Windows.Forms.RadioButton
    Friend WithEvents RadioButton3 As System.Windows.Forms.RadioButton
    Friend WithEvents RadioButton4 As System.Windows.Forms.RadioButton
    Friend WithEvents Panel2 As System.Windows.Forms.Panel
    Friend WithEvents Label17 As System.Windows.Forms.Label
    Friend WithEvents Label18 As System.Windows.Forms.Label
    Friend WithEvents Label19 As System.Windows.Forms.Label
    Friend WithEvents Label20 As System.Windows.Forms.Label
    Friend WithEvents Label21 As System.Windows.Forms.Label
    Friend WithEvents Label22 As System.Windows.Forms.Label
    Friend WithEvents ComboBox7 As System.Windows.Forms.ComboBox
    Friend WithEvents ComboBox8 As System.Windows.Forms.ComboBox
    Friend WithEvents ComboBox9 As System.Windows.Forms.ComboBox
    Friend WithEvents ComboBox10 As System.Windows.Forms.ComboBox
    Friend WithEvents ComboBox11 As System.Windows.Forms.ComboBox
    Friend WithEvents ComboBox12 As System.Windows.Forms.ComboBox
    Friend WithEvents TextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents OptPanel2 As System.Windows.Forms.Panel
    Friend WithEvents OptPanel1 As System.Windows.Forms.Panel
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(GUISetting))
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.OpenFileDialog1 = New System.Windows.Forms.OpenFileDialog
        Me.Button1 = New System.Windows.Forms.Button
        Me.Button2 = New System.Windows.Forms.Button
        Me.AdvanceGB = New System.Windows.Forms.GroupBox
        Me.Label9 = New System.Windows.Forms.Label
        Me.Label8 = New System.Windows.Forms.Label
        Me.Label7 = New System.Windows.Forms.Label
        Me.Label6 = New System.Windows.Forms.Label
        Me.Label5 = New System.Windows.Forms.Label
        Me.Label4 = New System.Windows.Forms.Label
        Me.urCBox = New System.Windows.Forms.ComboBox
        Me.upCBox = New System.Windows.Forms.ComboBox
        Me.usCBox = New System.Windows.Forms.ComboBox
        Me.formCBox = New System.Windows.Forms.ComboBox
        Me.udCBox = New System.Windows.Forms.ComboBox
        Me.utCBox = New System.Windows.Forms.ComboBox
        Me.CustomTxt = New System.Windows.Forms.TextBox
        Me.GroupBox2 = New System.Windows.Forms.GroupBox
        Me.LogChk = New System.Windows.Forms.CheckBox
        Me.ClearBtn = New System.Windows.Forms.Button
        Me.Label10 = New System.Windows.Forms.Label
        Me.DaysUpDown = New System.Windows.Forms.NumericUpDown
        Me.TimeUpDown = New System.Windows.Forms.NumericUpDown
        Me.BrowseBtn = New System.Windows.Forms.Button
        Me.TranslationTxt = New System.Windows.Forms.TextBox
        Me.DaysLbl = New System.Windows.Forms.Label
        Me.TimeLbl = New System.Windows.Forms.Label
        Me.IDtxt = New System.Windows.Forms.TextBox
        Me.label1 = New System.Windows.Forms.Label
        Me.SearchBTN = New System.Windows.Forms.Button
        Me.OptPanel2 = New System.Windows.Forms.Panel
        Me.Label15 = New System.Windows.Forms.Label
        Me.Button3 = New System.Windows.Forms.Button
        Me.Button4 = New System.Windows.Forms.Button
        Me.CustomBtn = New System.Windows.Forms.RadioButton
        Me.MetricBtn = New System.Windows.Forms.RadioButton
        Me.EnglishBtn = New System.Windows.Forms.RadioButton
        Me.AmericanBtn = New System.Windows.Forms.RadioButton
        Me.CustomPnl = New System.Windows.Forms.Panel
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label3 = New System.Windows.Forms.Label
        Me.Label11 = New System.Windows.Forms.Label
        Me.Label12 = New System.Windows.Forms.Label
        Me.Label13 = New System.Windows.Forms.Label
        Me.Label14 = New System.Windows.Forms.Label
        Me.ComboBox1 = New System.Windows.Forms.ComboBox
        Me.ComboBox2 = New System.Windows.Forms.ComboBox
        Me.ComboBox3 = New System.Windows.Forms.ComboBox
        Me.ComboBox4 = New System.Windows.Forms.ComboBox
        Me.ComboBox5 = New System.Windows.Forms.ComboBox
        Me.ComboBox6 = New System.Windows.Forms.ComboBox
        Me.TextBox1 = New System.Windows.Forms.TextBox
        Me.OptionsBar = New Weather.vbAccelerator.Controls.ListBar.ButtonListBar
        Me.BarIcons = New System.Windows.Forms.ImageList(Me.components)
        Me.OptPanel1 = New System.Windows.Forms.Panel
        Me.Label16 = New System.Windows.Forms.Label
        Me.Button5 = New System.Windows.Forms.Button
        Me.Button6 = New System.Windows.Forms.Button
        Me.RadioButton1 = New System.Windows.Forms.RadioButton
        Me.RadioButton2 = New System.Windows.Forms.RadioButton
        Me.RadioButton3 = New System.Windows.Forms.RadioButton
        Me.RadioButton4 = New System.Windows.Forms.RadioButton
        Me.Panel2 = New System.Windows.Forms.Panel
        Me.Label17 = New System.Windows.Forms.Label
        Me.Label18 = New System.Windows.Forms.Label
        Me.Label19 = New System.Windows.Forms.Label
        Me.Label20 = New System.Windows.Forms.Label
        Me.Label21 = New System.Windows.Forms.Label
        Me.Label22 = New System.Windows.Forms.Label
        Me.ComboBox7 = New System.Windows.Forms.ComboBox
        Me.ComboBox8 = New System.Windows.Forms.ComboBox
        Me.ComboBox9 = New System.Windows.Forms.ComboBox
        Me.ComboBox10 = New System.Windows.Forms.ComboBox
        Me.ComboBox11 = New System.Windows.Forms.ComboBox
        Me.ComboBox12 = New System.Windows.Forms.ComboBox
        Me.TextBox2 = New System.Windows.Forms.TextBox
        Me.AdvanceGB.SuspendLayout()
        Me.GroupBox2.SuspendLayout()
        CType(Me.DaysUpDown, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.TimeUpDown, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.OptPanel2.SuspendLayout()
        Me.CustomPnl.SuspendLayout()
        Me.OptPanel1.SuspendLayout()
        Me.Panel2.SuspendLayout()
        Me.SuspendLayout()
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(56, 664)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(88, 24)
        Me.Button1.TabIndex = 21
        Me.Button1.Text = "Apply"
        '
        'Button2
        '
        Me.Button2.Location = New System.Drawing.Point(160, 664)
        Me.Button2.Name = "Button2"
        Me.Button2.Size = New System.Drawing.Size(88, 24)
        Me.Button2.TabIndex = 22
        Me.Button2.Text = "Cancel"
        '
        'AdvanceGB
        '
        Me.AdvanceGB.Controls.Add(Me.Label9)
        Me.AdvanceGB.Controls.Add(Me.Label8)
        Me.AdvanceGB.Controls.Add(Me.Label7)
        Me.AdvanceGB.Controls.Add(Me.Label6)
        Me.AdvanceGB.Controls.Add(Me.Label5)
        Me.AdvanceGB.Controls.Add(Me.Label4)
        Me.AdvanceGB.Controls.Add(Me.urCBox)
        Me.AdvanceGB.Controls.Add(Me.upCBox)
        Me.AdvanceGB.Controls.Add(Me.usCBox)
        Me.AdvanceGB.Controls.Add(Me.formCBox)
        Me.AdvanceGB.Controls.Add(Me.udCBox)
        Me.AdvanceGB.Controls.Add(Me.utCBox)
        Me.AdvanceGB.Controls.Add(Me.CustomTxt)
        Me.AdvanceGB.Location = New System.Drawing.Point(272, 416)
        Me.AdvanceGB.Name = "AdvanceGB"
        Me.AdvanceGB.Size = New System.Drawing.Size(248, 240)
        Me.AdvanceGB.TabIndex = 25
        Me.AdvanceGB.TabStop = False
        '
        'Label9
        '
        Me.Label9.Location = New System.Drawing.Point(24, 176)
        Me.Label9.Name = "Label9"
        Me.Label9.Size = New System.Drawing.Size(112, 24)
        Me.Label9.TabIndex = 29
        Me.Label9.Text = "Unit of Presure"
        Me.Label9.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label8
        '
        Me.Label8.Location = New System.Drawing.Point(24, 144)
        Me.Label8.Name = "Label8"
        Me.Label8.Size = New System.Drawing.Size(112, 24)
        Me.Label8.TabIndex = 28
        Me.Label8.Text = "Unit of Precipitation"
        Me.Label8.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label7
        '
        Me.Label7.Location = New System.Drawing.Point(24, 112)
        Me.Label7.Name = "Label7"
        Me.Label7.Size = New System.Drawing.Size(112, 24)
        Me.Label7.TabIndex = 27
        Me.Label7.Text = "Unit of Speed"
        Me.Label7.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label6
        '
        Me.Label6.Location = New System.Drawing.Point(24, 80)
        Me.Label6.Name = "Label6"
        Me.Label6.Size = New System.Drawing.Size(112, 24)
        Me.Label6.TabIndex = 26
        Me.Label6.Text = "Unit of Distance"
        Me.Label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label5
        '
        Me.Label5.Location = New System.Drawing.Point(24, 48)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(112, 24)
        Me.Label5.TabIndex = 25
        Me.Label5.Text = "Unit of Temperature"
        Me.Label5.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label4
        '
        Me.Label4.Location = New System.Drawing.Point(8, 16)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(128, 24)
        Me.Label4.TabIndex = 24
        Me.Label4.Text = "Format of the document"
        Me.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'urCBox
        '
        Me.urCBox.Location = New System.Drawing.Point(152, 176)
        Me.urCBox.Name = "urCBox"
        Me.urCBox.Size = New System.Drawing.Size(72, 21)
        Me.urCBox.TabIndex = 23
        '
        'upCBox
        '
        Me.upCBox.Location = New System.Drawing.Point(152, 144)
        Me.upCBox.Name = "upCBox"
        Me.upCBox.Size = New System.Drawing.Size(72, 21)
        Me.upCBox.TabIndex = 22
        '
        'usCBox
        '
        Me.usCBox.Location = New System.Drawing.Point(152, 112)
        Me.usCBox.Name = "usCBox"
        Me.usCBox.Size = New System.Drawing.Size(72, 21)
        Me.usCBox.TabIndex = 21
        '
        'formCBox
        '
        Me.formCBox.Location = New System.Drawing.Point(152, 16)
        Me.formCBox.Name = "formCBox"
        Me.formCBox.Size = New System.Drawing.Size(72, 21)
        Me.formCBox.TabIndex = 20
        '
        'udCBox
        '
        Me.udCBox.Location = New System.Drawing.Point(152, 80)
        Me.udCBox.Name = "udCBox"
        Me.udCBox.Size = New System.Drawing.Size(72, 21)
        Me.udCBox.TabIndex = 19
        '
        'utCBox
        '
        Me.utCBox.Location = New System.Drawing.Point(152, 48)
        Me.utCBox.Name = "utCBox"
        Me.utCBox.Size = New System.Drawing.Size(72, 21)
        Me.utCBox.TabIndex = 18
        '
        'CustomTxt
        '
        Me.CustomTxt.BackColor = System.Drawing.SystemColors.Window
        Me.CustomTxt.Location = New System.Drawing.Point(8, 208)
        Me.CustomTxt.Name = "CustomTxt"
        Me.CustomTxt.ReadOnly = True
        Me.CustomTxt.Size = New System.Drawing.Size(232, 20)
        Me.CustomTxt.TabIndex = 17
        Me.CustomTxt.Text = ""
        '
        'GroupBox2
        '
        Me.GroupBox2.Controls.Add(Me.LogChk)
        Me.GroupBox2.Controls.Add(Me.ClearBtn)
        Me.GroupBox2.Controls.Add(Me.Label10)
        Me.GroupBox2.Controls.Add(Me.DaysUpDown)
        Me.GroupBox2.Controls.Add(Me.TimeUpDown)
        Me.GroupBox2.Controls.Add(Me.BrowseBtn)
        Me.GroupBox2.Controls.Add(Me.TranslationTxt)
        Me.GroupBox2.Controls.Add(Me.DaysLbl)
        Me.GroupBox2.Controls.Add(Me.TimeLbl)
        Me.GroupBox2.Controls.Add(Me.IDtxt)
        Me.GroupBox2.Controls.Add(Me.label1)
        Me.GroupBox2.Controls.Add(Me.SearchBTN)
        Me.GroupBox2.Location = New System.Drawing.Point(16, 416)
        Me.GroupBox2.Name = "GroupBox2"
        Me.GroupBox2.Size = New System.Drawing.Size(248, 240)
        Me.GroupBox2.TabIndex = 26
        Me.GroupBox2.TabStop = False
        '
        'LogChk
        '
        Me.LogChk.Location = New System.Drawing.Point(152, 109)
        Me.LogChk.Name = "LogChk"
        Me.LogChk.Size = New System.Drawing.Size(80, 16)
        Me.LogChk.TabIndex = 40
        Me.LogChk.Text = "Enable Log"
        Me.LogChk.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'ClearBtn
        '
        Me.ClearBtn.Location = New System.Drawing.Point(168, 16)
        Me.ClearBtn.Name = "ClearBtn"
        Me.ClearBtn.Size = New System.Drawing.Size(64, 24)
        Me.ClearBtn.TabIndex = 39
        Me.ClearBtn.Text = "Clear ID's"
        '
        'Label10
        '
        Me.Label10.Location = New System.Drawing.Point(16, 184)
        Me.Label10.Name = "Label10"
        Me.Label10.Size = New System.Drawing.Size(88, 16)
        Me.Label10.TabIndex = 38
        Me.Label10.Text = "Translation File:"
        '
        'DaysUpDown
        '
        Me.DaysUpDown.Location = New System.Drawing.Point(96, 104)
        Me.DaysUpDown.Maximum = New Decimal(New Integer() {10, 0, 0, 0})
        Me.DaysUpDown.Name = "DaysUpDown"
        Me.DaysUpDown.Size = New System.Drawing.Size(40, 20)
        Me.DaysUpDown.TabIndex = 36
        '
        'TimeUpDown
        '
        Me.TimeUpDown.Location = New System.Drawing.Point(96, 72)
        Me.TimeUpDown.Maximum = New Decimal(New Integer() {86340000, 0, 0, 0})
        Me.TimeUpDown.Minimum = New Decimal(New Integer() {1000, 0, 0, 0})
        Me.TimeUpDown.Name = "TimeUpDown"
        Me.TimeUpDown.Size = New System.Drawing.Size(96, 20)
        Me.TimeUpDown.TabIndex = 35
        Me.TimeUpDown.Value = New Decimal(New Integer() {1000, 0, 0, 0})
        '
        'BrowseBtn
        '
        Me.BrowseBtn.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.BrowseBtn.Location = New System.Drawing.Point(208, 204)
        Me.BrowseBtn.Name = "BrowseBtn"
        Me.BrowseBtn.Size = New System.Drawing.Size(24, 24)
        Me.BrowseBtn.TabIndex = 34
        Me.BrowseBtn.Text = "..."
        Me.BrowseBtn.TextAlign = System.Drawing.ContentAlignment.BottomLeft
        '
        'TranslationTxt
        '
        Me.TranslationTxt.Location = New System.Drawing.Point(16, 204)
        Me.TranslationTxt.Name = "TranslationTxt"
        Me.TranslationTxt.Size = New System.Drawing.Size(184, 20)
        Me.TranslationTxt.TabIndex = 33
        Me.TranslationTxt.Text = ""
        '
        'DaysLbl
        '
        Me.DaysLbl.Location = New System.Drawing.Point(8, 104)
        Me.DaysLbl.Name = "DaysLbl"
        Me.DaysLbl.Size = New System.Drawing.Size(88, 23)
        Me.DaysLbl.TabIndex = 32
        Me.DaysLbl.Text = "Number of Days"
        Me.DaysLbl.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'TimeLbl
        '
        Me.TimeLbl.Location = New System.Drawing.Point(8, 72)
        Me.TimeLbl.Name = "TimeLbl"
        Me.TimeLbl.Size = New System.Drawing.Size(104, 23)
        Me.TimeLbl.TabIndex = 31
        Me.TimeLbl.Text = "Refresh Time"
        Me.TimeLbl.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'IDtxt
        '
        Me.IDtxt.Location = New System.Drawing.Point(8, 45)
        Me.IDtxt.MaxLength = 100
        Me.IDtxt.Name = "IDtxt"
        Me.IDtxt.Size = New System.Drawing.Size(232, 20)
        Me.IDtxt.TabIndex = 26
        Me.IDtxt.Text = ""
        '
        'label1
        '
        Me.label1.Location = New System.Drawing.Point(8, 16)
        Me.label1.Name = "label1"
        Me.label1.Size = New System.Drawing.Size(88, 23)
        Me.label1.TabIndex = 25
        Me.label1.Text = "Weather.com ID"
        Me.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'SearchBTN
        '
        Me.SearchBTN.Location = New System.Drawing.Point(104, 16)
        Me.SearchBTN.Name = "SearchBTN"
        Me.SearchBTN.Size = New System.Drawing.Size(48, 24)
        Me.SearchBTN.TabIndex = 37
        Me.SearchBTN.Text = "Add ID"
        '
        'OptPanel2
        '
        Me.OptPanel2.Controls.Add(Me.Label15)
        Me.OptPanel2.Controls.Add(Me.Button3)
        Me.OptPanel2.Controls.Add(Me.Button4)
        Me.OptPanel2.Controls.Add(Me.CustomBtn)
        Me.OptPanel2.Controls.Add(Me.MetricBtn)
        Me.OptPanel2.Controls.Add(Me.EnglishBtn)
        Me.OptPanel2.Controls.Add(Me.AmericanBtn)
        Me.OptPanel2.Controls.Add(Me.CustomPnl)
        Me.OptPanel2.Location = New System.Drawing.Point(120, 8)
        Me.OptPanel2.Name = "OptPanel2"
        Me.OptPanel2.Size = New System.Drawing.Size(536, 344)
        Me.OptPanel2.TabIndex = 30
        '
        'Label15
        '
        Me.Label15.BackColor = System.Drawing.Color.Transparent
        Me.Label15.Font = New System.Drawing.Font("Tahoma", 18.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label15.Location = New System.Drawing.Point(0, 0)
        Me.Label15.Name = "Label15"
        Me.Label15.Size = New System.Drawing.Size(536, 24)
        Me.Label15.TabIndex = 37
        Me.Label15.Text = "Weather.com Measurment Units"
        Me.Label15.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Button3
        '
        Me.Button3.Location = New System.Drawing.Point(192, 312)
        Me.Button3.Name = "Button3"
        Me.Button3.Size = New System.Drawing.Size(88, 24)
        Me.Button3.TabIndex = 36
        Me.Button3.Text = "Cancel"
        '
        'Button4
        '
        Me.Button4.Location = New System.Drawing.Point(32, 312)
        Me.Button4.Name = "Button4"
        Me.Button4.Size = New System.Drawing.Size(88, 24)
        Me.Button4.TabIndex = 35
        Me.Button4.Text = "Apply"
        '
        'CustomBtn
        '
        Me.CustomBtn.Location = New System.Drawing.Point(160, 56)
        Me.CustomBtn.Name = "CustomBtn"
        Me.CustomBtn.Size = New System.Drawing.Size(80, 24)
        Me.CustomBtn.TabIndex = 34
        Me.CustomBtn.Text = "Custom"
        '
        'MetricBtn
        '
        Me.MetricBtn.Location = New System.Drawing.Point(64, 56)
        Me.MetricBtn.Name = "MetricBtn"
        Me.MetricBtn.Size = New System.Drawing.Size(80, 24)
        Me.MetricBtn.TabIndex = 33
        Me.MetricBtn.Text = "Metric"
        '
        'EnglishBtn
        '
        Me.EnglishBtn.Location = New System.Drawing.Point(160, 32)
        Me.EnglishBtn.Name = "EnglishBtn"
        Me.EnglishBtn.Size = New System.Drawing.Size(80, 24)
        Me.EnglishBtn.TabIndex = 32
        Me.EnglishBtn.Text = "English"
        '
        'AmericanBtn
        '
        Me.AmericanBtn.Location = New System.Drawing.Point(64, 32)
        Me.AmericanBtn.Name = "AmericanBtn"
        Me.AmericanBtn.Size = New System.Drawing.Size(80, 24)
        Me.AmericanBtn.TabIndex = 31
        Me.AmericanBtn.Text = "American"
        '
        'CustomPnl
        '
        Me.CustomPnl.Controls.Add(Me.Label2)
        Me.CustomPnl.Controls.Add(Me.Label3)
        Me.CustomPnl.Controls.Add(Me.Label11)
        Me.CustomPnl.Controls.Add(Me.Label12)
        Me.CustomPnl.Controls.Add(Me.Label13)
        Me.CustomPnl.Controls.Add(Me.Label14)
        Me.CustomPnl.Controls.Add(Me.ComboBox1)
        Me.CustomPnl.Controls.Add(Me.ComboBox2)
        Me.CustomPnl.Controls.Add(Me.ComboBox3)
        Me.CustomPnl.Controls.Add(Me.ComboBox4)
        Me.CustomPnl.Controls.Add(Me.ComboBox5)
        Me.CustomPnl.Controls.Add(Me.ComboBox6)
        Me.CustomPnl.Controls.Add(Me.TextBox1)
        Me.CustomPnl.Location = New System.Drawing.Point(32, 80)
        Me.CustomPnl.Name = "CustomPnl"
        Me.CustomPnl.Size = New System.Drawing.Size(248, 224)
        Me.CustomPnl.TabIndex = 31
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 168)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(112, 24)
        Me.Label2.TabIndex = 73
        Me.Label2.Text = "Unit of Presure"
        Me.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(24, 136)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(112, 24)
        Me.Label3.TabIndex = 72
        Me.Label3.Text = "Unit of Precipitation"
        Me.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label11
        '
        Me.Label11.Location = New System.Drawing.Point(24, 104)
        Me.Label11.Name = "Label11"
        Me.Label11.Size = New System.Drawing.Size(112, 24)
        Me.Label11.TabIndex = 71
        Me.Label11.Text = "Unit of Speed"
        Me.Label11.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label12
        '
        Me.Label12.Location = New System.Drawing.Point(24, 72)
        Me.Label12.Name = "Label12"
        Me.Label12.Size = New System.Drawing.Size(112, 24)
        Me.Label12.TabIndex = 70
        Me.Label12.Text = "Unit of Distance"
        Me.Label12.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label13
        '
        Me.Label13.Location = New System.Drawing.Point(24, 40)
        Me.Label13.Name = "Label13"
        Me.Label13.Size = New System.Drawing.Size(112, 24)
        Me.Label13.TabIndex = 69
        Me.Label13.Text = "Unit of Temperature"
        Me.Label13.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label14
        '
        Me.Label14.Location = New System.Drawing.Point(8, 8)
        Me.Label14.Name = "Label14"
        Me.Label14.Size = New System.Drawing.Size(128, 24)
        Me.Label14.TabIndex = 68
        Me.Label14.Text = "Format of the document"
        Me.Label14.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'ComboBox1
        '
        Me.ComboBox1.Location = New System.Drawing.Point(152, 168)
        Me.ComboBox1.Name = "ComboBox1"
        Me.ComboBox1.Size = New System.Drawing.Size(72, 21)
        Me.ComboBox1.TabIndex = 67
        '
        'ComboBox2
        '
        Me.ComboBox2.Location = New System.Drawing.Point(152, 136)
        Me.ComboBox2.Name = "ComboBox2"
        Me.ComboBox2.Size = New System.Drawing.Size(72, 21)
        Me.ComboBox2.TabIndex = 66
        '
        'ComboBox3
        '
        Me.ComboBox3.Location = New System.Drawing.Point(152, 104)
        Me.ComboBox3.Name = "ComboBox3"
        Me.ComboBox3.Size = New System.Drawing.Size(72, 21)
        Me.ComboBox3.TabIndex = 65
        '
        'ComboBox4
        '
        Me.ComboBox4.Location = New System.Drawing.Point(152, 8)
        Me.ComboBox4.Name = "ComboBox4"
        Me.ComboBox4.Size = New System.Drawing.Size(72, 21)
        Me.ComboBox4.TabIndex = 64
        '
        'ComboBox5
        '
        Me.ComboBox5.Location = New System.Drawing.Point(152, 72)
        Me.ComboBox5.Name = "ComboBox5"
        Me.ComboBox5.Size = New System.Drawing.Size(72, 21)
        Me.ComboBox5.TabIndex = 63
        '
        'ComboBox6
        '
        Me.ComboBox6.Location = New System.Drawing.Point(152, 40)
        Me.ComboBox6.Name = "ComboBox6"
        Me.ComboBox6.Size = New System.Drawing.Size(72, 21)
        Me.ComboBox6.TabIndex = 62
        '
        'TextBox1
        '
        Me.TextBox1.BackColor = System.Drawing.SystemColors.Window
        Me.TextBox1.Location = New System.Drawing.Point(8, 200)
        Me.TextBox1.Name = "TextBox1"
        Me.TextBox1.ReadOnly = True
        Me.TextBox1.Size = New System.Drawing.Size(232, 20)
        Me.TextBox1.TabIndex = 61
        Me.TextBox1.Text = ""
        '
        'OptionsBar
        '
        Me.OptionsBar.AutoScroll = True
        Me.OptionsBar.BackColor = System.Drawing.SystemColors.Control
        Me.OptionsBar.ButtonWidth = 96
        Me.OptionsBar.ForeColor = System.Drawing.SystemColors.ControlText
        Me.OptionsBar.ImageList = Nothing
        Me.OptionsBar.Location = New System.Drawing.Point(8, 8)
        Me.OptionsBar.Name = "OptionsBar"
        Me.OptionsBar.Size = New System.Drawing.Size(112, 344)
        Me.OptionsBar.TabIndex = 31
        Me.OptionsBar.ToolTip = Nothing
        '
        'BarIcons
        '
        Me.BarIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit
        Me.BarIcons.ImageSize = New System.Drawing.Size(32, 32)
        Me.BarIcons.ImageStream = CType(resources.GetObject("BarIcons.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.BarIcons.TransparentColor = System.Drawing.Color.Transparent
        '
        'OptPanel1
        '
        Me.OptPanel1.Controls.Add(Me.Label16)
        Me.OptPanel1.Controls.Add(Me.Button5)
        Me.OptPanel1.Controls.Add(Me.Button6)
        Me.OptPanel1.Controls.Add(Me.RadioButton1)
        Me.OptPanel1.Controls.Add(Me.RadioButton2)
        Me.OptPanel1.Controls.Add(Me.RadioButton3)
        Me.OptPanel1.Controls.Add(Me.RadioButton4)
        Me.OptPanel1.Controls.Add(Me.Panel2)
        Me.OptPanel1.Location = New System.Drawing.Point(512, 376)
        Me.OptPanel1.Name = "OptPanel1"
        Me.OptPanel1.Size = New System.Drawing.Size(536, 344)
        Me.OptPanel1.TabIndex = 32
        '
        'Label16
        '
        Me.Label16.BackColor = System.Drawing.Color.Transparent
        Me.Label16.Font = New System.Drawing.Font("Tahoma", 18.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label16.Location = New System.Drawing.Point(0, 0)
        Me.Label16.Name = "Label16"
        Me.Label16.Size = New System.Drawing.Size(536, 24)
        Me.Label16.TabIndex = 37
        Me.Label16.Text = "Weather.com Location ID's"
        Me.Label16.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Button5
        '
        Me.Button5.Location = New System.Drawing.Point(192, 312)
        Me.Button5.Name = "Button5"
        Me.Button5.Size = New System.Drawing.Size(88, 24)
        Me.Button5.TabIndex = 36
        Me.Button5.Text = "Cancel"
        '
        'Button6
        '
        Me.Button6.Location = New System.Drawing.Point(32, 312)
        Me.Button6.Name = "Button6"
        Me.Button6.Size = New System.Drawing.Size(88, 24)
        Me.Button6.TabIndex = 35
        Me.Button6.Text = "Apply"
        '
        'RadioButton1
        '
        Me.RadioButton1.Location = New System.Drawing.Point(160, 56)
        Me.RadioButton1.Name = "RadioButton1"
        Me.RadioButton1.Size = New System.Drawing.Size(80, 24)
        Me.RadioButton1.TabIndex = 34
        Me.RadioButton1.Text = "Custom"
        '
        'RadioButton2
        '
        Me.RadioButton2.Location = New System.Drawing.Point(64, 56)
        Me.RadioButton2.Name = "RadioButton2"
        Me.RadioButton2.Size = New System.Drawing.Size(80, 24)
        Me.RadioButton2.TabIndex = 33
        Me.RadioButton2.Text = "Metric"
        '
        'RadioButton3
        '
        Me.RadioButton3.Location = New System.Drawing.Point(160, 32)
        Me.RadioButton3.Name = "RadioButton3"
        Me.RadioButton3.Size = New System.Drawing.Size(80, 24)
        Me.RadioButton3.TabIndex = 32
        Me.RadioButton3.Text = "English"
        '
        'RadioButton4
        '
        Me.RadioButton4.Location = New System.Drawing.Point(64, 32)
        Me.RadioButton4.Name = "RadioButton4"
        Me.RadioButton4.Size = New System.Drawing.Size(80, 24)
        Me.RadioButton4.TabIndex = 31
        Me.RadioButton4.Text = "American"
        '
        'Panel2
        '
        Me.Panel2.Controls.Add(Me.Label17)
        Me.Panel2.Controls.Add(Me.Label18)
        Me.Panel2.Controls.Add(Me.Label19)
        Me.Panel2.Controls.Add(Me.Label20)
        Me.Panel2.Controls.Add(Me.Label21)
        Me.Panel2.Controls.Add(Me.Label22)
        Me.Panel2.Controls.Add(Me.ComboBox7)
        Me.Panel2.Controls.Add(Me.ComboBox8)
        Me.Panel2.Controls.Add(Me.ComboBox9)
        Me.Panel2.Controls.Add(Me.ComboBox10)
        Me.Panel2.Controls.Add(Me.ComboBox11)
        Me.Panel2.Controls.Add(Me.ComboBox12)
        Me.Panel2.Controls.Add(Me.TextBox2)
        Me.Panel2.Location = New System.Drawing.Point(32, 80)
        Me.Panel2.Name = "Panel2"
        Me.Panel2.Size = New System.Drawing.Size(248, 224)
        Me.Panel2.TabIndex = 31
        '
        'Label17
        '
        Me.Label17.Location = New System.Drawing.Point(24, 168)
        Me.Label17.Name = "Label17"
        Me.Label17.Size = New System.Drawing.Size(112, 24)
        Me.Label17.TabIndex = 73
        Me.Label17.Text = "Unit of Presure"
        Me.Label17.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label18
        '
        Me.Label18.Location = New System.Drawing.Point(24, 136)
        Me.Label18.Name = "Label18"
        Me.Label18.Size = New System.Drawing.Size(112, 24)
        Me.Label18.TabIndex = 72
        Me.Label18.Text = "Unit of Precipitation"
        Me.Label18.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label19
        '
        Me.Label19.Location = New System.Drawing.Point(24, 104)
        Me.Label19.Name = "Label19"
        Me.Label19.Size = New System.Drawing.Size(112, 24)
        Me.Label19.TabIndex = 71
        Me.Label19.Text = "Unit of Speed"
        Me.Label19.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label20
        '
        Me.Label20.Location = New System.Drawing.Point(24, 72)
        Me.Label20.Name = "Label20"
        Me.Label20.Size = New System.Drawing.Size(112, 24)
        Me.Label20.TabIndex = 70
        Me.Label20.Text = "Unit of Distance"
        Me.Label20.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label21
        '
        Me.Label21.Location = New System.Drawing.Point(24, 40)
        Me.Label21.Name = "Label21"
        Me.Label21.Size = New System.Drawing.Size(112, 24)
        Me.Label21.TabIndex = 69
        Me.Label21.Text = "Unit of Temperature"
        Me.Label21.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label22
        '
        Me.Label22.Location = New System.Drawing.Point(8, 8)
        Me.Label22.Name = "Label22"
        Me.Label22.Size = New System.Drawing.Size(128, 24)
        Me.Label22.TabIndex = 68
        Me.Label22.Text = "Format of the document"
        Me.Label22.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'ComboBox7
        '
        Me.ComboBox7.Location = New System.Drawing.Point(152, 168)
        Me.ComboBox7.Name = "ComboBox7"
        Me.ComboBox7.Size = New System.Drawing.Size(72, 21)
        Me.ComboBox7.TabIndex = 67
        '
        'ComboBox8
        '
        Me.ComboBox8.Location = New System.Drawing.Point(152, 136)
        Me.ComboBox8.Name = "ComboBox8"
        Me.ComboBox8.Size = New System.Drawing.Size(72, 21)
        Me.ComboBox8.TabIndex = 66
        '
        'ComboBox9
        '
        Me.ComboBox9.Location = New System.Drawing.Point(152, 104)
        Me.ComboBox9.Name = "ComboBox9"
        Me.ComboBox9.Size = New System.Drawing.Size(72, 21)
        Me.ComboBox9.TabIndex = 65
        '
        'ComboBox10
        '
        Me.ComboBox10.Location = New System.Drawing.Point(152, 8)
        Me.ComboBox10.Name = "ComboBox10"
        Me.ComboBox10.Size = New System.Drawing.Size(72, 21)
        Me.ComboBox10.TabIndex = 64
        '
        'ComboBox11
        '
        Me.ComboBox11.Location = New System.Drawing.Point(152, 72)
        Me.ComboBox11.Name = "ComboBox11"
        Me.ComboBox11.Size = New System.Drawing.Size(72, 21)
        Me.ComboBox11.TabIndex = 63
        '
        'ComboBox12
        '
        Me.ComboBox12.Location = New System.Drawing.Point(152, 40)
        Me.ComboBox12.Name = "ComboBox12"
        Me.ComboBox12.Size = New System.Drawing.Size(72, 21)
        Me.ComboBox12.TabIndex = 62
        '
        'TextBox2
        '
        Me.TextBox2.BackColor = System.Drawing.SystemColors.Window
        Me.TextBox2.Location = New System.Drawing.Point(8, 200)
        Me.TextBox2.Name = "TextBox2"
        Me.TextBox2.ReadOnly = True
        Me.TextBox2.Size = New System.Drawing.Size(232, 20)
        Me.TextBox2.TabIndex = 61
        Me.TextBox2.Text = ""
        '
        'GUISetting
        '
        Me.Controls.Add(Me.OptPanel1)
        Me.Controls.Add(Me.OptionsBar)
        Me.Controls.Add(Me.OptPanel2)
        Me.Controls.Add(Me.GroupBox2)
        Me.Controls.Add(Me.Button2)
        Me.Controls.Add(Me.Button1)
        Me.Controls.Add(Me.AdvanceGB)
        Me.Name = "GUISetting"
        Me.Size = New System.Drawing.Size(1088, 760)
        Me.AdvanceGB.ResumeLayout(False)
        Me.GroupBox2.ResumeLayout(False)
        CType(Me.DaysUpDown, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.TimeUpDown, System.ComponentModel.ISupportInitialize).EndInit()
        Me.OptPanel2.ResumeLayout(False)
        Me.CustomPnl.ResumeLayout(False)
        Me.OptPanel1.ResumeLayout(False)
        Me.Panel2.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "    Controls     "
    Private Sub AmericanBtn_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AmericanBtn.CheckedChanged
        AdvanceGB.Visible = False
    End Sub

    Private Sub EnglishBtn_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EnglishBtn.CheckedChanged
        AdvanceGB.Visible = False
    End Sub

    Private Sub MetricBtn_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MetricBtn.CheckedChanged
        AdvanceGB.Visible = False
    End Sub

    Private Sub CustomBtn_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CustomBtn.CheckedChanged
        CustomPnl.Enabled = True
    End Sub

    Private Sub BrowseBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BrowseBtn.Click
        Try
            With OpenFileDialog1
                'With statement is used to execute statements using a particular object, here,_
                'OpenFileDialog1
                .Filter = "Text files (*.txt)|*.txt|" & "All files|*.*"
                .Title = "Open Translation File"
                'setting filters so that Text files and All Files choice appears in the Files of Type box
                'in the dialog
                .ShowDialog()
                If .FileName <> Nothing Then
                    'showDialog method makes the dialog box visible at run time
                    TranslationTxt.Text = .FileName
                End If
            End With
        Catch es As Exception
        End Try
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        With _settings
            .NumDays = DaysUpDown.Value
            .Updatetime = TimeUpDown.Value
            .WeatherID = IDtxt.Text
            .enablelog = LogChk.Checked.ToString

            If AmericanBtn.Checked = True Then .TempFormat = "A"
            If EnglishBtn.Checked = True Then .TempFormat = "E"
            If MetricBtn.Checked = True Then .TempFormat = "M"

            If CustomBtn.Checked = True Then
                If Not CustomTxt.Text = "" Then
                    .TempFormat = CustomTxt.Text

                Else
                    .TempFormat = "A"
                End If
            End If

            If TranslationTxt.Text <> .Translation Then
                'TransTxt = New Plugin
                Plugin.TranslationRead = False
                .Translation = TranslationTxt.Text
            End If
        End With

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        With _settings
            DaysUpDown.Value = .NumDays
            TimeUpDown.Value = .Updatetime
            IDtxt.Text = .WeatherID
            If LogChk.Checked = True Then .enablelog = "True"
            If LogChk.Checked = False Then .enablelog = "False"

            Select Case UCase(.TempFormat)
                Case "A"
                    AmericanBtn.Checked = True
                    EnglishBtn.Checked = False
                    MetricBtn.Checked = False
                    CustomTxt.Enabled = False
                Case "E"
                    EnglishBtn.Checked = True
                    AmericanBtn.Checked = False
                    MetricBtn.Checked = False
                    CustomTxt.Enabled = False
                Case "M"
                    MetricBtn.Checked = True
                    AmericanBtn.Checked = False
                    EnglishBtn.Checked = False
                    CustomTxt.Enabled = False
                Case Else
                    CustomBtn.Checked = True
                    MetricBtn.Checked = False
                    AmericanBtn.Checked = False
                    EnglishBtn.Checked = False
                    AdvanceGB.Visible = True
                    If Not .TempFormat = "" Then
                        AdvancedSettings(.TempFormat)
                    Else
                        AmericanBtn.Checked = True
                        EnglishBtn.Checked = False
                        MetricBtn.Checked = False
                        AdvanceGB.Visible = False
                    End If
            End Select
            TranslationTxt.Text = .Translation
        End With
    End Sub

    Private Sub SearchBTN_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SearchBTN.Click
        Dim frmDialogue As New frmListBox
        frmDialogue.ShowDialog()
        If Not LocationIDString = "" Then
            If IDtxt.Text = "" Then
                IDtxt.Text = LocationIDString
            Else
                IDtxt.Text = IDtxt.Text & "," & LocationIDString
            End If
        End If
    End Sub

    Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Process.Start("www.weather.com")
    End Sub

    Private Sub formCBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles formCBox.SelectedIndexChanged
        AdSett(0) = formCBox.SelectedItem
        UpdateTextBox()
    End Sub

    Private Sub utCBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles utCBox.SelectedIndexChanged
        AdSett(1) = utCBox.SelectedItem
        UpdateTextBox()
    End Sub

    Private Sub udCBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles udCBox.SelectedIndexChanged
        AdSett(2) = udCBox.SelectedItem
        UpdateTextBox()
    End Sub

    Private Sub usCBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles usCBox.SelectedIndexChanged
        AdSett(3) = usCBox.SelectedItem
        UpdateTextBox()
    End Sub

    Private Sub upCBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles upCBox.SelectedIndexChanged
        AdSett(4) = upCBox.SelectedItem
        UpdateTextBox()
    End Sub

    Private Sub urCBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles urCBox.SelectedIndexChanged
        AdSett(5) = urCBox.SelectedItem
        UpdateTextBox()
    End Sub

    Private Sub ClearBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearBtn.Click
        IDtxt.Text = ""
    End Sub

#End Region

#Region "    Personal Functions     "

    Private Sub UpdateTextBox()
        CustomTxt.Text = Nothing
        If Not AdSett(0) = Nothing Then CustomTxt.Text = CustomTxt.Text & "&form=" & AdSett(0)
        If Not AdSett(1) = Nothing Then CustomTxt.Text = CustomTxt.Text & "&ut=" & AdSett(1)
        If Not AdSett(2) = Nothing Then CustomTxt.Text = CustomTxt.Text & "&ud=" & AdSett(2)
        If Not AdSett(3) = Nothing Then CustomTxt.Text = CustomTxt.Text & "&us=" & AdSett(3)
        If Not AdSett(4) = Nothing Then CustomTxt.Text = CustomTxt.Text & "&up=" & AdSett(4)
        If Not AdSett(5) = Nothing Then CustomTxt.Text = CustomTxt.Text & "&ur=" & AdSett(5)
    End Sub

    Private Function AdvancedSettings(ByVal AdSettings As String)
        Dim Split() As String = Nothing
        Dim input(1) As String
        Dim tmp_i As Integer

        Split = AdSettings.Split("&")
        For tmp_i = 0 To Split.Length - 1
            input = Split(tmp_i).Split("=")
            If input(0) = "form" Then formCBox.SelectedItem = input(1)
            If input(0) = "ut" Then utCBox.SelectedItem = input(1)
            If input(0) = "ud" Then udCBox.SelectedItem = input(1)
            If input(0) = "us" Then usCBox.SelectedItem = input(1)
            If input(0) = "up" Then upCBox.SelectedItem = input(1)
            If input(0) = "ur" Then urCBox.SelectedItem = input(1)
        Next
    End Function

#End Region



    Private Sub GUISetting_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim Back_colour As New System.Drawing.Color
        'OptionsBar.BackColor = System.Drawing.Color.Transparent
        Back_colour = System.Drawing.Color.Transparent
        OptionsBar.BackColor = Back_colour
        'UnitsPnl.BackColor = Back_colour
        OptionsBar.ImageList = BarIcons

        Dim Item(5) As ButtonListBarItem
        Item(0) = New ButtonListBarItem("Locations", 0)
        Item(1) = New ButtonListBarItem("Measurment Units", 1)
        Item(2) = New ButtonListBarItem("Advanced Settings", 2)
        Item(3) = New ButtonListBarItem("About/Links", 3)
        OptionsBar.Items.Add(Item)
        Dim PanelLocation As New System.Drawing.Point
        PanelLocation.X = 120
        PanelLocation.Y = 8
        OptPanel1.Location = PanelLocation
        OptPanel2.Location = PanelLocation
        OptPanel1.Visible = True
        OptPanel2.Visible = False
    End Sub


    Private Sub OptionsBar_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OptionsBar.Load

    End Sub
End Class