Imports System.io
Imports System.Xml
Module General
    Private TranslationArray1 As New ArrayList
    Private TranslationArray2 As New ArrayList

#Region "    TimeConversion     "
    Public Function ConvertmstoTime(ByVal ms As Double) As String
        Dim TimeArray(2) As String
        Dim myTimeSpan As New TimeSpan(0, 0, 0, 0, ms)
        TimeArray(0) = myTimeSpan.Hours
        TimeArray(1) = myTimeSpan.Minutes
        TimeArray(2) = myTimeSpan.Seconds
        Return TimeArray(0) & ":" & TimeArray(1) & ":" & TimeArray(2)
    End Function

    Public Function ConvertTimetoms(ByVal time As String) As Double
        Dim TimeArray(2) As String
        TimeArray = time.Split(":")
        Dim myTimeSpan As New TimeSpan(TimeArray(0), TimeArray(1), TimeArray(2))
        Return myTimeSpan.TotalMilliseconds
    End Function
#End Region

#Region "    JOJU Custom Variables     "
    Public Function CustomWind(ByVal WindDirection As String) As String
        Select Case WindDirection
            Case "S"
                Return "1"
            Case "SSW"
                Return "2"
            Case "SW"
                Return "3"
            Case "WSW"
                Return "4"
            Case "W"
                Return "5"
            Case "WNW"
                Return "6"
            Case "NW"
                Return "7"
            Case "NNW"
                Return "8"
            Case "N"
                Return "9"
            Case "NNE"
                Return "10"
            Case "NE"
                Return "11"
            Case "ENE"
                Return "12"
            Case "E"
                Return "13"
            Case "ESE"
                Return "14"
            Case "SE"
                Return "15"
            Case "SSE"
                Return "16"
            Case "VAR"
                Return "17"
            Case "CALM"
                Return "18"
            Case Else
                Return "0"
        End Select
    End Function

    Public Function CustomForce(ByVal Wind_Force As String) As String
        Select Case Convert.ToInt16(Wind_Force)
            Case 1 To 5
                Return "1"
            Case 6 To 11
                Return "2"
            Case 12 To 19
                Return "3"
            Case 20 To 28
                Return "4"
            Case 29 To 38
                Return "5"
            Case 39 To 49
                Return "6"
            Case 50 To 61
                Return "7"
            Case 62 To 74
                Return "8"
            Case 75 To 88
                Return "9"
            Case 89 To 99
                Return "10"
            Case 100 To 117
                Return "11"
            Case 118 To 125
                Return "12"
            Case Else
                Return "0"
        End Select
    End Function

#End Region

#Region "    Translate String     "
    Public Function TranslateString(ByVal The_String As String, ByVal FileName As String) As String
        Dim Location As Integer

        If Not FileName Is Nothing Then
            If Plugin.TranslationRead = False Then ReadTranslation(FileName)
            Location = TranslationArray1.IndexOf(LCase(The_String))

            If Location = -1 Then
                TranslateString = The_String
            Else
                TranslateString = TranslationArray2(Location)
            End If

        Else
            TranslateString = The_String
        End If

    End Function
#End Region

#Region "    Read Translation File     "
    Public Sub ReadTranslation(ByVal File_Name As String)
        'Dim tmp_i As Integer
        'Dim startpos As Integer
        'Dim endpos As Integer
        Dim Readline As String
        Dim input() As String
        Plugin.TranslationRead = False
        TranslationArray1.Clear()
        TranslationArray2.Clear()

        If System.IO.File.Exists(File_Name) = True Then
            Dim sr As StreamReader = File.OpenText(File_Name)
            Readline = sr.ReadLine
            'MsgBox(Readline)

            If Readline.IndexOf(LCase("lcdstudio weather plugin translation file")) Then
                'MsgBox("Verified File")
                Readline = sr.ReadLine
                'While Not input(0) Is Nothing
                Do
                    input = Split(Readline, "=")
                    'MsgBox("Input contains Value: " & Readline)
                    TranslationArray1.Add(input(0))
                    TranslationArray2.Add(input(1))
                    'MsgBox("TranslationArray1 contains Value: " & TranslationArray1(TranslationArray1.Count - 1))
                    'MsgBox("TranslationArray2 contains Value: " & TranslationArray2(TranslationArray2.Count - 1))
                    Readline = sr.ReadLine
                    'MsgBox("End Input Read Value: " & Readline)
                Loop Until Readline Is Nothing
                'End While
                'MsgBox("Closing Stream")
                Plugin.TranslationRead = True
            End If
            sr.Close()
            'TranslationText = Nothing
        End If
    End Sub
#End Region

#Region "    DebugLog     "
    Public Sub Log(ByVal logMessage As String) ', ByVal w As TextWriter)
        If Plugin.UseLog = True Then
            Try
                Dim w As StreamWriter = File.AppendText("WeatherLog.txt")
                w.Write(ControlChars.CrLf & "Log Entry : ")
                w.WriteLine("{0} {1}", DateTime.Now.ToLongTimeString(), DateTime.Now.ToLongDateString())
                'w.WriteLine("  :")
                w.WriteLine("  : {0}", logMessage)
                'w.WriteLine("-------------------------------")
                ' Update the underlying file.
                w.Flush()
                w.Close()
            Catch ex As Exception

            End Try
        End If
    End Sub
#End Region

#Region "    GetPageHTML     "
    Public Function GetPageHTML(ByVal URL As String, Optional ByVal TimeoutSeconds As Integer = 5, Optional ByVal proxy As String = Nothing, Optional ByRef LastError As String = Nothing, Optional ByVal Use_Cursor As Boolean = False) As String
        Dim Success As Boolean = True
        Try
            If Use_Cursor = True Then System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.WaitCursor
            For tmp_loop As Integer = 1 To 2
                Try
                    Dim ObjRequest As Net.HttpWebRequest = Net.WebRequest.Create(URL)
                    ObjRequest.UserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)"
                    ObjRequest.Timeout = TimeoutSeconds * 1000

                    If Not proxy = Nothing Then
                        Dim curProxy As New Net.WebProxy(proxy)
                        ObjRequest.Proxy = curProxy
                    End If
                    Dim ObjResponse As Net.HttpWebResponse = CType(ObjRequest.GetResponse(), Net.HttpWebResponse)

                    Dim objStreamReceive As System.IO.Stream
                    Dim objEncoding As System.Text.Encoding
                    Dim objStreamRead As System.IO.StreamReader

                    objStreamReceive = ObjResponse.GetResponseStream
                    objEncoding = System.Text.Encoding.GetEncoding( _
                        "utf-8")
                    objStreamRead = New System.IO.StreamReader( _
                        objStreamReceive, objEncoding)
                    ' Set function return value
                    GetPageHTML = objStreamRead.ReadToEnd()
                    ' Check if available, then close response
                    If Not ObjResponse Is Nothing Then
                        ObjResponse.Close()
                    End If
                Catch ex As Exception
                    Success = False
                    ' Error occured grabbing data, simply return nothing
                    'Lasterror = "Error Retriving URL " & URL
                    LastError = ex.Message
                    'Return ""
                End Try
                If Success = True Then Exit For
            Next

        Catch ex As Exception
            If Use_Cursor = True Then System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.Default
        End Try
        If Success = False Then Return ""
    End Function
#End Region

End Module
